# ##### BEGIN GPL LICENSE BLOCK #####
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 3
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software Foundation,
#  Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# ##### END GPL LICENSE BLOCK #####

# This script by Lionel Zamouth

ocs_header = "<?xml version='1.0' encoding='utf-8'?>"

template_ocs = """
    <OCS_1_0_23_Scene>
     <Node>
      <name>Unnamed Project</name>
      <typename>projectroot</typename>
      <id>0</id>
      <position>0 0</position>
      <inputnodepins>
      </inputnodepins>
      <childgraph>
       <NodeGraph>
        <name>Unnamed Project</name>
        <currentnewnodeid>4</currentnewnodeid>
        <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
        <nodes>
         <Node>
          <name>%%SYSTEM%%</name>
          <typename>macro</typename>
          <id>1</id>
          <position>0.1 0.2</position>
          <inputnodepins>
          </inputnodepins>
          <childgraph>
           <NodeGraph>
            <name>%%SYSTEM%%</name>
            <currentnewnodeid>31</currentnewnodeid>
            <currentnewnodepinconnectionid>34</currentnewnodepinconnectionid>
            <nodes>
             <Node>
              <name>%%WORKSPACEMANAGER%%</name>
              <typename>workspacemanager</typename>
              <id>1</id>
              <position>0 0</position>
              <inputnodepins>
               <NodePin>
                <typename>rootpane</typename>
                <id>0</id>
                <pintype>21000</pintype>
                <hasinternalnodegraph>false</hasinternalnodegraph>
               </NodePin>
              </inputnodepins>
             </Node>
             <Node>
              <name>rootsplitpane</name>
              <typename>splitpane</typename>
              <id>2</id>
              <position>0 0</position>
              <parameters>
               <maximized>false</maximized>
               <unmaxsplitvalue>0.5</unmaxsplitvalue>
               <isrootpanenode>true</isrootpanenode>
              </parameters>
              <inputnodepins>
               <NodePin>
                <typename>childpaneleft</typename>
                <id>0</id>
                <pintype>21000</pintype>
                <hasinternalnodegraph>false</hasinternalnodegraph>
               </NodePin>
               <NodePin>
                <typename>childpaneright</typename>
                <id>1</id>
                <pintype>21000</pintype>
                <hasinternalnodegraph>false</hasinternalnodegraph>
               </NodePin>
               <NodePin>
                <typename>splitvalue</typename>
                <id>2</id>
                <pintype>20001</pintype>
                <hasinternalnodegraph>false</hasinternalnodegraph>
               </NodePin>
               <NodePin>
                <typename>splitvertical</typename>
                <id>3</id>
                <pintype>20003</pintype>
                <hasinternalnodegraph>false</hasinternalnodegraph>
               </NodePin>
              </inputnodepins>
             </Node>
             <Node>
              <name>Split Value</name>
              <typename>float</typename>
              <id>3</id>
              <position>0 0</position>
              <parameters>
               <value>0.71875</value>
               <minvalue>0</minvalue>
               <maxvalue>1</maxvalue>
               <usetextureui>false</usetextureui>
               <usetexturealphaui>false</usetexturealphaui>
               <isloglincapable>true</isloglincapable>
               <uselogscale>false</uselogscale>
               <modified>true</modified>
              </parameters>
              <inputnodepins>
              </inputnodepins>
             </Node>
             <Node>
              <name>Split Axis</name>
              <typename>bool</typename>
              <id>4</id>
              <position>0 0</position>
              <parameters>
               <value>false</value>
               <modified>true</modified>
              </parameters>
              <inputnodepins>
              </inputnodepins>
             </Node>
             <Node>
              <name>leftsplitpane</name>
              <typename>splitpane</typename>
              <id>5</id>
              <position>0 0</position>
              <parameters>
               <maximized>false</maximized>
               <unmaxsplitvalue>0.5</unmaxsplitvalue>
               <isrootpanenode>false</isrootpanenode>
              </parameters>
              <inputnodepins>
               <NodePin>
                <typename>childpaneleft</typename>
                <id>0</id>
                <pintype>21000</pintype>
                <hasinternalnodegraph>false</hasinternalnodegraph>
               </NodePin>
               <NodePin>
                <typename>childpaneright</typename>
                <id>1</id>
                <pintype>21000</pintype>
                <hasinternalnodegraph>false</hasinternalnodegraph>
               </NodePin>
               <NodePin>
                <typename>splitvalue</typename>
                <id>2</id>
                <pintype>20001</pintype>
                <hasinternalnodegraph>false</hasinternalnodegraph>
               </NodePin>
               <NodePin>
                <typename>splitvertical</typename>
                <id>3</id>
                <pintype>20003</pintype>
                <hasinternalnodegraph>false</hasinternalnodegraph>
               </NodePin>
              </inputnodepins>
             </Node>
             <Node>
              <name>Split Value</name>
              <typename>float</typename>
              <id>6</id>
              <position>0 0</position>
              <parameters>
               <value>0.173913</value>
               <minvalue>0</minvalue>
               <maxvalue>1</maxvalue>
               <usetextureui>false</usetextureui>
               <usetexturealphaui>false</usetexturealphaui>
               <isloglincapable>true</isloglincapable>
               <uselogscale>false</uselogscale>
               <modified>true</modified>
              </parameters>
              <inputnodepins>
              </inputnodepins>
             </Node>
             <Node>
              <name>Split Axis</name>
              <typename>bool</typename>
              <id>7</id>
              <position>0 0</position>
              <parameters>
               <value>false</value>
               <modified>true</modified>
              </parameters>
              <inputnodepins>
              </inputnodepins>
             </Node>
             <Node>
              <name>centersplitpane</name>
              <typename>splitpane</typename>
              <id>8</id>
              <position>0 0</position>
              <parameters>
               <maximized>false</maximized>
               <unmaxsplitvalue>0.5</unmaxsplitvalue>
               <isrootpanenode>false</isrootpanenode>
              </parameters>
              <inputnodepins>
               <NodePin>
                <typename>childpaneleft</typename>
                <id>0</id>
                <pintype>21000</pintype>
                <hasinternalnodegraph>false</hasinternalnodegraph>
               </NodePin>
               <NodePin>
                <typename>childpaneright</typename>
                <id>1</id>
                <pintype>21000</pintype>
                <hasinternalnodegraph>false</hasinternalnodegraph>
               </NodePin>
               <NodePin>
                <typename>splitvalue</typename>
                <id>2</id>
                <pintype>20001</pintype>
                <hasinternalnodegraph>false</hasinternalnodegraph>
               </NodePin>
               <NodePin>
                <typename>splitvertical</typename>
                <id>3</id>
                <pintype>20003</pintype>
                <hasinternalnodegraph>false</hasinternalnodegraph>
               </NodePin>
              </inputnodepins>
             </Node>
             <Node>
              <name>Split Value</name>
              <typename>float</typename>
              <id>9</id>
              <position>0 0</position>
              <parameters>
               <value>0.600694</value>
               <minvalue>0</minvalue>
               <maxvalue>1</maxvalue>
               <usetextureui>false</usetextureui>
               <usetexturealphaui>false</usetexturealphaui>
               <isloglincapable>true</isloglincapable>
               <uselogscale>false</uselogscale>
               <modified>true</modified>
              </parameters>
              <inputnodepins>
              </inputnodepins>
             </Node>
             <Node>
              <name>Split Axis</name>
              <typename>bool</typename>
              <id>10</id>
              <position>0 0</position>
              <parameters>
               <value>true</value>
               <modified>true</modified>
              </parameters>
              <inputnodepins>
              </inputnodepins>
             </Node>
             <Node>
              <name>%%WORKPANE NODE%%</name>
              <typename>workpane</typename>
              <id>11</id>
              <position>0 0</position>
              <parameters>
               <ismaximized>false</ismaximized>
               <isrootpanenode>false</isrootpanenode>
              </parameters>
              <inputnodepins>
               <NodePin>
                <typename>defaultstate</typename>
                <id>0</id>
                <pintype>21000</pintype>
                <hasinternalnodegraph>false</hasinternalnodegraph>
               </NodePin>
               <NodePin>
                <typename>nodegrapheditorstate</typename>
                <id>1</id>
                <pintype>21000</pintype>
                <hasinternalnodegraph>false</hasinternalnodegraph>
               </NodePin>
               <NodePin>
                <typename>nodestackeditorstate</typename>
                <id>2</id>
                <pintype>21000</pintype>
                <hasinternalnodegraph>false</hasinternalnodegraph>
               </NodePin>
               <NodePin>
                <typename>rendererstate</typename>
                <id>3</id>
                <pintype>21000</pintype>
                <hasinternalnodegraph>false</hasinternalnodegraph>
               </NodePin>
               <NodePin>
                <typename>outlinerstate</typename>
                <id>4</id>
                <pintype>21000</pintype>
                <hasinternalnodegraph>false</hasinternalnodegraph>
               </NodePin>
              </inputnodepins>
             </Node>
             <Node>
              <name>%%NODEGRAPHEDITORPANESTATE NODE%%</name>
              <typename>nodegrapheditorpanestate</typename>
              <id>12</id>
              <position>0 0</position>
              <inputnodepins>
              </inputnodepins>
             </Node>
             <Node>
              <name>%%NODESTACKEDITORPANESTATE NODE%%</name>
              <typename>nodestackeditorpanestate</typename>
              <id>13</id>
              <position>0 0</position>
              <inputnodepins>
              </inputnodepins>
             </Node>
             <Node>
              <name>%%RENDERERPANESTATE NODE%%</name>
              <typename>rendererpanestate</typename>
              <id>14</id>
              <position>0 0</position>
              <inputnodepins>
              </inputnodepins>
             </Node>
             <Node>
              <name>%%OUTLINERPANESTATE NODE%%</name>
              <typename>outlinerpanestate</typename>
              <id>15</id>
              <position>0 0</position>
              <inputnodepins>
              </inputnodepins>
             </Node>
             <Node>
              <name>%%WORKPANE NODE%%</name>
              <typename>workpane</typename>
              <id>16</id>
              <position>0 0</position>
              <parameters>
               <ismaximized>false</ismaximized>
               <isrootpanenode>false</isrootpanenode>
              </parameters>
              <inputnodepins>
               <NodePin>
                <typename>defaultstate</typename>
                <id>0</id>
                <pintype>21000</pintype>
                <hasinternalnodegraph>false</hasinternalnodegraph>
               </NodePin>
               <NodePin>
                <typename>nodegrapheditorstate</typename>
                <id>1</id>
                <pintype>21000</pintype>
                <hasinternalnodegraph>false</hasinternalnodegraph>
               </NodePin>
               <NodePin>
                <typename>nodestackeditorstate</typename>
                <id>2</id>
                <pintype>21000</pintype>
                <hasinternalnodegraph>false</hasinternalnodegraph>
               </NodePin>
               <NodePin>
                <typename>rendererstate</typename>
                <id>3</id>
                <pintype>21000</pintype>
                <hasinternalnodegraph>false</hasinternalnodegraph>
               </NodePin>
               <NodePin>
                <typename>outlinerstate</typename>
                <id>4</id>
                <pintype>21000</pintype>
                <hasinternalnodegraph>false</hasinternalnodegraph>
               </NodePin>
              </inputnodepins>
             </Node>
             <Node>
              <name>%%NODEGRAPHEDITORPANESTATE NODE%%</name>
              <typename>nodegrapheditorpanestate</typename>
              <id>17</id>
              <position>0 0</position>
              <inputnodepins>
              </inputnodepins>
             </Node>
             <Node>
              <name>%%NODESTACKEDITORPANESTATE NODE%%</name>
              <typename>nodestackeditorpanestate</typename>
              <id>18</id>
              <position>0 0</position>
              <inputnodepins>
              </inputnodepins>
             </Node>
             <Node>
              <name>%%RENDERERPANESTATE NODE%%</name>
              <typename>rendererpanestate</typename>
              <id>19</id>
              <position>0 0</position>
              <inputnodepins>
              </inputnodepins>
             </Node>
             <Node>
              <name>%%OUTLINERPANESTATE NODE%%</name>
              <typename>outlinerpanestate</typename>
              <id>20</id>
              <position>0 0</position>
              <inputnodepins>
              </inputnodepins>
             </Node>
             <Node>
              <name>%%WORKPANE NODE%%</name>
              <typename>workpane</typename>
              <id>21</id>
              <position>0 0</position>
              <parameters>
               <ismaximized>false</ismaximized>
               <isrootpanenode>false</isrootpanenode>
              </parameters>
              <inputnodepins>
               <NodePin>
                <typename>defaultstate</typename>
                <id>0</id>
                <pintype>21000</pintype>
                <hasinternalnodegraph>false</hasinternalnodegraph>
               </NodePin>
               <NodePin>
                <typename>nodegrapheditorstate</typename>
                <id>1</id>
                <pintype>21000</pintype>
                <hasinternalnodegraph>false</hasinternalnodegraph>
               </NodePin>
               <NodePin>
                <typename>nodestackeditorstate</typename>
                <id>2</id>
                <pintype>21000</pintype>
                <hasinternalnodegraph>false</hasinternalnodegraph>
               </NodePin>
               <NodePin>
                <typename>rendererstate</typename>
                <id>3</id>
                <pintype>21000</pintype>
                <hasinternalnodegraph>false</hasinternalnodegraph>
               </NodePin>
               <NodePin>
                <typename>outlinerstate</typename>
                <id>4</id>
                <pintype>21000</pintype>
                <hasinternalnodegraph>false</hasinternalnodegraph>
               </NodePin>
              </inputnodepins>
             </Node>
             <Node>
              <name>%%NODEGRAPHEDITORPANESTATE NODE%%</name>
              <typename>nodegrapheditorpanestate</typename>
              <id>22</id>
              <position>0 0</position>
              <inputnodepins>
              </inputnodepins>
             </Node>
             <Node>
              <name>%%NODESTACKEDITORPANESTATE NODE%%</name>
              <typename>nodestackeditorpanestate</typename>
              <id>23</id>
              <position>0 0</position>
              <inputnodepins>
              </inputnodepins>
             </Node>
             <Node>
              <name>%%RENDERERPANESTATE NODE%%</name>
              <typename>rendererpanestate</typename>
              <id>24</id>
              <position>0 0</position>
              <inputnodepins>
              </inputnodepins>
             </Node>
             <Node>
              <name>%%OUTLINERPANESTATE NODE%%</name>
              <typename>outlinerpanestate</typename>
              <id>25</id>
              <position>0 0</position>
              <inputnodepins>
              </inputnodepins>
             </Node>
             <Node>
              <name>%%WORKPANE NODE%%</name>
              <typename>workpane</typename>
              <id>26</id>
              <position>0 0</position>
              <parameters>
               <ismaximized>false</ismaximized>
               <isrootpanenode>false</isrootpanenode>
              </parameters>
              <inputnodepins>
               <NodePin>
                <typename>defaultstate</typename>
                <id>0</id>
                <pintype>21000</pintype>
                <hasinternalnodegraph>false</hasinternalnodegraph>
               </NodePin>
               <NodePin>
                <typename>nodegrapheditorstate</typename>
                <id>1</id>
                <pintype>21000</pintype>
                <hasinternalnodegraph>false</hasinternalnodegraph>
               </NodePin>
               <NodePin>
                <typename>nodestackeditorstate</typename>
                <id>2</id>
                <pintype>21000</pintype>
                <hasinternalnodegraph>false</hasinternalnodegraph>
               </NodePin>
               <NodePin>
                <typename>rendererstate</typename>
                <id>3</id>
                <pintype>21000</pintype>
                <hasinternalnodegraph>false</hasinternalnodegraph>
               </NodePin>
               <NodePin>
                <typename>outlinerstate</typename>
                <id>4</id>
                <pintype>21000</pintype>
                <hasinternalnodegraph>false</hasinternalnodegraph>
               </NodePin>
              </inputnodepins>
             </Node>
             <Node>
              <name>%%NODEGRAPHEDITORPANESTATE NODE%%</name>
              <typename>nodegrapheditorpanestate</typename>
              <id>27</id>
              <position>0 0</position>
              <inputnodepins>
              </inputnodepins>
             </Node>
             <Node>
              <name>%%NODESTACKEDITORPANESTATE NODE%%</name>
              <typename>nodestackeditorpanestate</typename>
              <id>28</id>
              <position>0 0</position>
              <inputnodepins>
              </inputnodepins>
             </Node>
             <Node>
              <name>%%RENDERERPANESTATE NODE%%</name>
              <typename>rendererpanestate</typename>
              <id>29</id>
              <position>0 0</position>
              <inputnodepins>
              </inputnodepins>
             </Node>
             <Node>
              <name>%%OUTLINERPANESTATE NODE%%</name>
              <typename>outlinerpanestate</typename>
              <id>30</id>
              <position>0 0</position>
              <inputnodepins>
              </inputnodepins>
             </Node>
            </nodes>
            <nodepinconnections>
             <nodepinconnection>
              <sourceid>3</sourceid>
              <sourcepinid>0</sourcepinid>
              <destid>2</destid>
              <destpinid>2</destpinid>
             </nodepinconnection>
             <nodepinconnection>
              <sourceid>4</sourceid>
              <sourcepinid>0</sourcepinid>
              <destid>2</destid>
              <destpinid>3</destpinid>
             </nodepinconnection>
             <nodepinconnection>
              <sourceid>2</sourceid>
              <sourcepinid>0</sourcepinid>
              <destid>1</destid>
              <destpinid>0</destpinid>
             </nodepinconnection>
             <nodepinconnection>
              <sourceid>6</sourceid>
              <sourcepinid>0</sourcepinid>
              <destid>5</destid>
              <destpinid>2</destpinid>
             </nodepinconnection>
             <nodepinconnection>
              <sourceid>7</sourceid>
              <sourcepinid>0</sourcepinid>
              <destid>5</destid>
              <destpinid>3</destpinid>
             </nodepinconnection>
             <nodepinconnection>
              <sourceid>5</sourceid>
              <sourcepinid>0</sourcepinid>
              <destid>2</destid>
              <destpinid>0</destpinid>
             </nodepinconnection>
             <nodepinconnection>
              <sourceid>9</sourceid>
              <sourcepinid>0</sourcepinid>
              <destid>8</destid>
              <destpinid>2</destpinid>
             </nodepinconnection>
             <nodepinconnection>
              <sourceid>10</sourceid>
              <sourcepinid>0</sourcepinid>
              <destid>8</destid>
              <destpinid>3</destpinid>
             </nodepinconnection>
             <nodepinconnection>
              <sourceid>8</sourceid>
              <sourcepinid>0</sourcepinid>
              <destid>5</destid>
              <destpinid>1</destpinid>
             </nodepinconnection>
             <nodepinconnection>
              <sourceid>12</sourceid>
              <sourcepinid>0</sourcepinid>
              <destid>11</destid>
              <destpinid>1</destpinid>
             </nodepinconnection>
             <nodepinconnection>
              <sourceid>13</sourceid>
              <sourcepinid>0</sourcepinid>
              <destid>11</destid>
              <destpinid>2</destpinid>
             </nodepinconnection>
             <nodepinconnection>
              <sourceid>14</sourceid>
              <sourcepinid>0</sourcepinid>
              <destid>11</destid>
              <destpinid>3</destpinid>
             </nodepinconnection>
             <nodepinconnection>
              <sourceid>15</sourceid>
              <sourcepinid>0</sourcepinid>
              <destid>11</destid>
              <destpinid>4</destpinid>
             </nodepinconnection>
             <nodepinconnection>
              <sourceid>15</sourceid>
              <sourcepinid>0</sourcepinid>
              <destid>11</destid>
              <destpinid>0</destpinid>
             </nodepinconnection>
             <nodepinconnection>
              <sourceid>11</sourceid>
              <sourcepinid>0</sourcepinid>
              <destid>5</destid>
              <destpinid>0</destpinid>
             </nodepinconnection>
             <nodepinconnection>
              <sourceid>17</sourceid>
              <sourcepinid>0</sourcepinid>
              <destid>16</destid>
              <destpinid>1</destpinid>
             </nodepinconnection>
             <nodepinconnection>
              <sourceid>18</sourceid>
              <sourcepinid>0</sourcepinid>
              <destid>16</destid>
              <destpinid>2</destpinid>
             </nodepinconnection>
             <nodepinconnection>
              <sourceid>19</sourceid>
              <sourcepinid>0</sourcepinid>
              <destid>16</destid>
              <destpinid>3</destpinid>
             </nodepinconnection>
             <nodepinconnection>
              <sourceid>20</sourceid>
              <sourcepinid>0</sourcepinid>
              <destid>16</destid>
              <destpinid>4</destpinid>
             </nodepinconnection>
             <nodepinconnection>
              <sourceid>19</sourceid>
              <sourcepinid>0</sourcepinid>
              <destid>16</destid>
              <destpinid>0</destpinid>
             </nodepinconnection>
             <nodepinconnection>
              <sourceid>16</sourceid>
              <sourcepinid>0</sourcepinid>
              <destid>8</destid>
              <destpinid>0</destpinid>
             </nodepinconnection>
             <nodepinconnection>
              <sourceid>22</sourceid>
              <sourcepinid>0</sourcepinid>
              <destid>21</destid>
              <destpinid>1</destpinid>
             </nodepinconnection>
             <nodepinconnection>
              <sourceid>23</sourceid>
              <sourcepinid>0</sourcepinid>
              <destid>21</destid>
              <destpinid>2</destpinid>
             </nodepinconnection>
             <nodepinconnection>
              <sourceid>24</sourceid>
              <sourcepinid>0</sourcepinid>
              <destid>21</destid>
              <destpinid>3</destpinid>
             </nodepinconnection>
             <nodepinconnection>
              <sourceid>25</sourceid>
              <sourcepinid>0</sourcepinid>
              <destid>21</destid>
              <destpinid>4</destpinid>
             </nodepinconnection>
             <nodepinconnection>
              <sourceid>22</sourceid>
              <sourcepinid>0</sourcepinid>
              <destid>21</destid>
              <destpinid>0</destpinid>
             </nodepinconnection>
             <nodepinconnection>
              <sourceid>21</sourceid>
              <sourcepinid>0</sourcepinid>
              <destid>8</destid>
              <destpinid>1</destpinid>
             </nodepinconnection>
             <nodepinconnection>
              <sourceid>27</sourceid>
              <sourcepinid>0</sourcepinid>
              <destid>26</destid>
              <destpinid>1</destpinid>
             </nodepinconnection>
             <nodepinconnection>
              <sourceid>28</sourceid>
              <sourcepinid>0</sourcepinid>
              <destid>26</destid>
              <destpinid>2</destpinid>
             </nodepinconnection>
             <nodepinconnection>
              <sourceid>29</sourceid>
              <sourcepinid>0</sourcepinid>
              <destid>26</destid>
              <destpinid>3</destpinid>
             </nodepinconnection>
             <nodepinconnection>
              <sourceid>30</sourceid>
              <sourcepinid>0</sourcepinid>
              <destid>26</destid>
              <destpinid>4</destpinid>
             </nodepinconnection>
             <nodepinconnection>
              <sourceid>28</sourceid>
              <sourcepinid>0</sourcepinid>
              <destid>26</destid>
              <destpinid>0</destpinid>
             </nodepinconnection>
             <nodepinconnection>
              <sourceid>26</sourceid>
              <sourcepinid>0</sourcepinid>
              <destid>2</destid>
              <destpinid>1</destpinid>
             </nodepinconnection>
            </nodepinconnections>
           </NodeGraph>
          </childgraph>
         </Node>
         <Node>
          <name>Preview Configuration</name>
          <typename>macro</typename>
          <id>2</id>
          <position>0.1 0.1</position>
          <inputnodepins>
          </inputnodepins>
          <childgraph>
           <NodeGraph>
            <name>Preview Configuration</name>
            <currentnewnodeid>7</currentnewnodeid>
            <currentnewnodepinconnectionid>6</currentnewnodepinconnectionid>
            <nodes>
             <Node>
              <name>Mesh Preview RenderTarget</name>
              <typename>rendertarget</typename>
              <id>1</id>
              <position>0.296 1.0625</position>
              <inputnodepins>
               <NodePin>
                <typename>camera</typename>
                <id>0</id>
                <pintype>21000</pintype>
                <hasinternalnodegraph>false</hasinternalnodegraph>
               </NodePin>
               <NodePin>
                <typename>resolution</typename>
                <id>1</id>
                <pintype>20002</pintype>
                <hasinternalnodegraph>false</hasinternalnodegraph>
               </NodePin>
               <NodePin>
                <typename>environment</typename>
                <id>2</id>
                <pintype>21000</pintype>
                <hasinternalnodegraph>false</hasinternalnodegraph>
               </NodePin>
               <NodePin>
                <typename>imager</typename>
                <id>3</id>
                <pintype>21000</pintype>
                <hasinternalnodegraph>false</hasinternalnodegraph>
               </NodePin>
               <NodePin>
                <typename>kernel</typename>
                <id>4</id>
                <pintype>21000</pintype>
                <hasinternalnodegraph>false</hasinternalnodegraph>
               </NodePin>
              </inputnodepins>
             </Node>
             <Node>
              <name>Mesh Preview Camera</name>
              <typename>thinlens</typename>
              <id>2</id>
              <position>0.166 0.68</position>
              <inputnodepins>
               <NodePin>
                <typename>fov</typename>
                <id>0</id>
                <pintype>20001</pintype>
                <hasinternalnodegraph>true</hasinternalnodegraph>
                <basenodeid>1</basenodeid>
                <basenodepinid>0</basenodepinid>
                <internalnodegraph>
                 <NodeGraph>
                  <name>fov</name>
                  <currentnewnodeid>2</currentnewnodeid>
                  <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
                  <nodes>
                   <Node>
                    <name>fov</name>
                    <typename>float</typename>
                    <id>1</id>
                    <position>0 0</position>
                    <parameters>
                     <value>45</value>
                     <minvalue>1</minvalue>
                     <maxvalue>180</maxvalue>
                     <usetextureui>false</usetextureui>
                     <usetexturealphaui>false</usetexturealphaui>
                     <isloglincapable>true</isloglincapable>
                     <uselogscale>true</uselogscale>
                     <modified>true</modified>
                    </parameters>
                    <inputnodepins>
                    </inputnodepins>
                   </Node>
                  </nodes>
                  <nodepinconnections>
                  </nodepinconnections>
                 </NodeGraph>
                </internalnodegraph>
               </NodePin>
               <NodePin>
                <typename>aperture</typename>
                <id>1</id>
                <pintype>20001</pintype>
                <hasinternalnodegraph>true</hasinternalnodegraph>
                <basenodeid>1</basenodeid>
                <basenodepinid>0</basenodepinid>
                <internalnodegraph>
                 <NodeGraph>
                  <name>aperture</name>
                  <currentnewnodeid>2</currentnewnodeid>
                  <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
                  <nodes>
                   <Node>
                    <name>aperture</name>
                    <typename>float</typename>
                    <id>1</id>
                    <position>0 0</position>
                    <parameters>
                     <value>1</value>
                     <minvalue>0.01</minvalue>
                     <maxvalue>100</maxvalue>
                     <usetextureui>false</usetextureui>
                     <usetexturealphaui>false</usetexturealphaui>
                     <isloglincapable>true</isloglincapable>
                     <uselogscale>true</uselogscale>
                     <modified>true</modified>
                    </parameters>
                    <inputnodepins>
                    </inputnodepins>
                   </Node>
                  </nodes>
                  <nodepinconnections>
                  </nodepinconnections>
                 </NodeGraph>
                </internalnodegraph>
               </NodePin>
               <NodePin>
                <typename>pos</typename>
                <id>2</id>
                <pintype>20001</pintype>
                <hasinternalnodegraph>true</hasinternalnodegraph>
                <basenodeid>1</basenodeid>
                <basenodepinid>0</basenodepinid>
                <internalnodegraph>
                 <NodeGraph>
                  <name>pos</name>
                  <currentnewnodeid>2</currentnewnodeid>
                  <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
                  <nodes>
                   <Node>
                    <name>pos</name>
                    <typename>float3</typename>
                    <id>1</id>
                    <position>0 0</position>
                    <parameters>
                     <valuexyz>0 0 10</valuexyz>
                     <minvalue>-100000</minvalue>
                     <maxvalue>100000</maxvalue>
                     <modified>true</modified>
                    </parameters>
                    <inputnodepins>
                    </inputnodepins>
                   </Node>
                  </nodes>
                  <nodepinconnections>
                  </nodepinconnections>
                 </NodeGraph>
                </internalnodegraph>
               </NodePin>
               <NodePin>
                <typename>target</typename>
                <id>3</id>
                <pintype>20001</pintype>
                <hasinternalnodegraph>true</hasinternalnodegraph>
                <basenodeid>1</basenodeid>
                <basenodepinid>0</basenodepinid>
                <internalnodegraph>
                 <NodeGraph>
                  <name>target</name>
                  <currentnewnodeid>2</currentnewnodeid>
                  <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
                  <nodes>
                   <Node>
                    <name>target</name>
                    <typename>float3</typename>
                    <id>1</id>
                    <position>0 0</position>
                    <parameters>
                     <valuexyz>0 0 0</valuexyz>
                     <minvalue>-100000</minvalue>
                     <maxvalue>100000</maxvalue>
                     <modified>true</modified>
                    </parameters>
                    <inputnodepins>
                    </inputnodepins>
                   </Node>
                  </nodes>
                  <nodepinconnections>
                  </nodepinconnections>
                 </NodeGraph>
                </internalnodegraph>
               </NodePin>
               <NodePin>
                <typename>up</typename>
                <id>4</id>
                <pintype>20001</pintype>
                <hasinternalnodegraph>true</hasinternalnodegraph>
                <basenodeid>1</basenodeid>
                <basenodepinid>0</basenodepinid>
                <internalnodegraph>
                 <NodeGraph>
                  <name>up</name>
                  <currentnewnodeid>2</currentnewnodeid>
                  <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
                  <nodes>
                   <Node>
                    <name>up</name>
                    <typename>float3</typename>
                    <id>1</id>
                    <position>0 0</position>
                    <parameters>
                     <valuexyz>0 1 0</valuexyz>
                     <minvalue>-1</minvalue>
                     <maxvalue>1</maxvalue>
                     <modified>true</modified>
                    </parameters>
                    <inputnodepins>
                    </inputnodepins>
                   </Node>
                  </nodes>
                  <nodepinconnections>
                  </nodepinconnections>
                 </NodeGraph>
                </internalnodegraph>
               </NodePin>
               <NodePin>
                <typename>stereo</typename>
                <id>5</id>
                <pintype>20003</pintype>
                <hasinternalnodegraph>true</hasinternalnodegraph>
                <basenodeid>1</basenodeid>
                <basenodepinid>0</basenodepinid>
                <internalnodegraph>
                 <NodeGraph>
                  <name>stereo</name>
                  <currentnewnodeid>2</currentnewnodeid>
                  <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
                  <nodes>
                   <Node>
                    <name>stereo</name>
                    <typename>bool</typename>
                    <id>1</id>
                    <position>0 0</position>
                    <parameters>
                     <value>false</value>
                     <modified>true</modified>
                    </parameters>
                    <inputnodepins>
                    </inputnodepins>
                   </Node>
                  </nodes>
                  <nodepinconnections>
                  </nodepinconnections>
                 </NodeGraph>
                </internalnodegraph>
               </NodePin>
               <NodePin>
                <typename>stereodist</typename>
                <id>6</id>
                <pintype>20001</pintype>
                <hasinternalnodegraph>true</hasinternalnodegraph>
                <basenodeid>1</basenodeid>
                <basenodepinid>0</basenodepinid>
                <internalnodegraph>
                 <NodeGraph>
                  <name>stereodist</name>
                  <currentnewnodeid>2</currentnewnodeid>
                  <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
                  <nodes>
                   <Node>
                    <name>stereodist</name>
                    <typename>float</typename>
                    <id>1</id>
                    <position>0 0</position>
                    <parameters>
                     <value>0.02</value>
                     <minvalue>0.001</minvalue>
                     <maxvalue>2</maxvalue>
                     <usetextureui>false</usetextureui>
                     <usetexturealphaui>false</usetexturealphaui>
                     <isloglincapable>true</isloglincapable>
                     <uselogscale>true</uselogscale>
                     <modified>true</modified>
                    </parameters>
                    <inputnodepins>
                    </inputnodepins>
                   </Node>
                  </nodes>
                  <nodepinconnections>
                  </nodepinconnections>
                 </NodeGraph>
                </internalnodegraph>
               </NodePin>
               <NodePin>
                <typename>leftFilter</typename>
                <id>7</id>
                <pintype>20000</pintype>
                <hasinternalnodegraph>true</hasinternalnodegraph>
                <basenodeid>1</basenodeid>
                <basenodepinid>0</basenodepinid>
                <internalnodegraph>
                 <NodeGraph>
                  <name>leftFilter</name>
                  <currentnewnodeid>2</currentnewnodeid>
                  <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
                  <nodes>
                   <Node>
                    <name>leftFilter</name>
                    <typename>RGBspectrum</typename>
                    <id>1</id>
                    <position>0 0</position>
                    <parameters>
                     <rgbvalue>1 0 0.812</rgbvalue>
                    </parameters>
                    <inputnodepins>
                    </inputnodepins>
                   </Node>
                  </nodes>
                  <nodepinconnections>
                  </nodepinconnections>
                 </NodeGraph>
                </internalnodegraph>
               </NodePin>
               <NodePin>
                <typename>rightFilter</typename>
                <id>8</id>
                <pintype>20000</pintype>
                <hasinternalnodegraph>true</hasinternalnodegraph>
                <basenodeid>1</basenodeid>
                <basenodepinid>0</basenodepinid>
                <internalnodegraph>
                 <NodeGraph>
                  <name>rightFilter</name>
                  <currentnewnodeid>2</currentnewnodeid>
                  <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
                  <nodes>
                   <Node>
                    <name>rightFilter</name>
                    <typename>RGBspectrum</typename>
                    <id>1</id>
                    <position>0 0</position>
                    <parameters>
                     <rgbvalue>0 1 0.188</rgbvalue>
                    </parameters>
                    <inputnodepins>
                    </inputnodepins>
                   </Node>
                  </nodes>
                  <nodepinconnections>
                  </nodepinconnections>
                 </NodeGraph>
                </internalnodegraph>
               </NodePin>
               <NodePin>
                <typename>lensShift</typename>
                <id>9</id>
                <pintype>20001</pintype>
                <hasinternalnodegraph>true</hasinternalnodegraph>
                <basenodeid>1</basenodeid>
                <basenodepinid>0</basenodepinid>
                <internalnodegraph>
                 <NodeGraph>
                  <name>lensShift</name>
                  <currentnewnodeid>2</currentnewnodeid>
                  <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
                  <nodes>
                   <Node>
                    <name>lensShift</name>
                    <typename>float2</typename>
                    <id>1</id>
                    <position>0 0</position>
                    <parameters>
                     <valuexy>0 0</valuexy>
                     <minvalue>-4</minvalue>
                     <maxvalue>4</maxvalue>
                     <modified>true</modified>
                    </parameters>
                    <inputnodepins>
                    </inputnodepins>
                   </Node>
                  </nodes>
                  <nodepinconnections>
                  </nodepinconnections>
                 </NodeGraph>
                </internalnodegraph>
               </NodePin>
              </inputnodepins>
             </Node>
             <Node>
              <name>Mesh Preview Environment</name>
              <typename>texture environment</typename>
              <id>3</id>
              <position>0.403 0.68</position>
              <inputnodepins>
               <NodePin>
                <typename>texture</typename>
                <id>0</id>
                <pintype>20000</pintype>
                <hasinternalnodegraph>true</hasinternalnodegraph>
                <basenodeid>1</basenodeid>
                <basenodepinid>0</basenodepinid>
                <internalnodegraph>
                 <NodeGraph>
                  <name>texture</name>
                  <currentnewnodeid>2</currentnewnodeid>
                  <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
                  <nodes>
                   <Node>
                    <name>texture</name>
                    <typename>floattexture</typename>
                    <id>1</id>
                    <position>0 0</position>
                    <parameters>
                     <value>1</value>
                     <minvalue>0</minvalue>
                     <maxvalue>1</maxvalue>
                     <usetexturealphaui>false</usetexturealphaui>
                     <isloglincapable>false</isloglincapable>
                     <uselogscale>false</uselogscale>
                     <resolution>0.001</resolution>
                     <modified>true</modified>
                    </parameters>
                    <inputnodepins>
                    </inputnodepins>
                   </Node>
                  </nodes>
                  <nodepinconnections>
                  </nodepinconnections>
                 </NodeGraph>
                </internalnodegraph>
               </NodePin>
               <NodePin>
                <typename>power</typename>
                <id>1</id>
                <pintype>20001</pintype>
                <hasinternalnodegraph>true</hasinternalnodegraph>
                <basenodeid>1</basenodeid>
                <basenodepinid>0</basenodepinid>
                <internalnodegraph>
                 <NodeGraph>
                  <name>power</name>
                  <currentnewnodeid>2</currentnewnodeid>
                  <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
                  <nodes>
                   <Node>
                    <name>power</name>
                    <typename>float</typename>
                    <id>1</id>
                    <position>0 0</position>
                    <parameters>
                     <value>1</value>
                     <minvalue>0.001</minvalue>
                     <maxvalue>1000</maxvalue>
                     <usetextureui>false</usetextureui>
                     <usetexturealphaui>false</usetexturealphaui>
                     <isloglincapable>true</isloglincapable>
                     <uselogscale>true</uselogscale>
                     <modified>true</modified>
                    </parameters>
                    <inputnodepins>
                    </inputnodepins>
                   </Node>
                  </nodes>
                  <nodepinconnections>
                  </nodepinconnections>
                 </NodeGraph>
                </internalnodegraph>
               </NodePin>
               <NodePin>
                <typename>rotation</typename>
                <id>2</id>
                <pintype>20001</pintype>
                <hasinternalnodegraph>true</hasinternalnodegraph>
                <basenodeid>1</basenodeid>
                <basenodepinid>0</basenodepinid>
                <internalnodegraph>
                 <NodeGraph>
                  <name>rotation</name>
                  <currentnewnodeid>2</currentnewnodeid>
                  <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
                  <nodes>
                   <Node>
                    <name>rotation</name>
                    <typename>float2</typename>
                    <id>1</id>
                    <position>0 0</position>
                    <parameters>
                     <valuexy>0 0</valuexy>
                     <minvalue>-1</minvalue>
                     <maxvalue>1</maxvalue>
                     <modified>true</modified>
                    </parameters>
                    <inputnodepins>
                    </inputnodepins>
                   </Node>
                  </nodes>
                  <nodepinconnections>
                  </nodepinconnections>
                 </NodeGraph>
                </internalnodegraph>
               </NodePin>
              </inputnodepins>
             </Node>
             <Node>
              <name>Mesh Preview Resolution</name>
              <typename>int2resolution</typename>
              <id>4</id>
              <position>0.197 0.5025</position>
              <parameters>
               <valuexy>960 540</valuexy>
               <presetid>1212</presetid>
               <minvalue>4</minvalue>
               <maxvalue>8192</maxvalue>
               <modified>true</modified>
              </parameters>
              <inputnodepins>
              </inputnodepins>
             </Node>
             <Node>
              <name>Mesh Preview Imager</name>
              <typename>camera</typename>
              <id>5</id>
              <position>0.272 0.8725</position>
              <inputnodepins>
               <NodePin>
                <typename>exposure</typename>
                <id>0</id>
                <pintype>20001</pintype>
                <hasinternalnodegraph>true</hasinternalnodegraph>
                <basenodeid>1</basenodeid>
                <basenodepinid>0</basenodepinid>
                <internalnodegraph>
                 <NodeGraph>
                  <name>exposure</name>
                  <currentnewnodeid>2</currentnewnodeid>
                  <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
                  <nodes>
                   <Node>
                    <name>exposure</name>
                    <typename>float</typename>
                    <id>1</id>
                    <position>0 0</position>
                    <parameters>
                     <value>1</value>
                     <minvalue>0.001</minvalue>
                     <maxvalue>4096</maxvalue>
                     <usetextureui>false</usetextureui>
                     <usetexturealphaui>false</usetexturealphaui>
                     <isloglincapable>true</isloglincapable>
                     <uselogscale>true</uselogscale>
                     <modified>true</modified>
                    </parameters>
                    <inputnodepins>
                    </inputnodepins>
                   </Node>
                  </nodes>
                  <nodepinconnections>
                  </nodepinconnections>
                 </NodeGraph>
                </internalnodegraph>
               </NodePin>
               <NodePin>
                <typename>fstop</typename>
                <id>1</id>
                <pintype>20001</pintype>
                <hasinternalnodegraph>true</hasinternalnodegraph>
                <basenodeid>1</basenodeid>
                <basenodepinid>0</basenodepinid>
                <internalnodegraph>
                 <NodeGraph>
                  <name>fstop</name>
                  <currentnewnodeid>2</currentnewnodeid>
                  <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
                  <nodes>
                   <Node>
                    <name>fstop</name>
                    <typename>float</typename>
                    <id>1</id>
                    <position>0 0</position>
                    <parameters>
                     <value>2.8</value>
                     <minvalue>1</minvalue>
                     <maxvalue>64</maxvalue>
                     <usetextureui>false</usetextureui>
                     <usetexturealphaui>false</usetexturealphaui>
                     <isloglincapable>true</isloglincapable>
                     <uselogscale>true</uselogscale>
                     <modified>true</modified>
                    </parameters>
                    <inputnodepins>
                    </inputnodepins>
                   </Node>
                  </nodes>
                  <nodepinconnections>
                  </nodepinconnections>
                 </NodeGraph>
                </internalnodegraph>
               </NodePin>
               <NodePin>
                <typename>ISO</typename>
                <id>2</id>
                <pintype>20001</pintype>
                <hasinternalnodegraph>true</hasinternalnodegraph>
                <basenodeid>1</basenodeid>
                <basenodepinid>0</basenodepinid>
                <internalnodegraph>
                 <NodeGraph>
                  <name>ISO</name>
                  <currentnewnodeid>2</currentnewnodeid>
                  <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
                  <nodes>
                   <Node>
                    <name>ISO</name>
                    <typename>float</typename>
                    <id>1</id>
                    <position>0 0</position>
                    <parameters>
                     <value>100</value>
                     <minvalue>1</minvalue>
                     <maxvalue>800</maxvalue>
                     <usetextureui>false</usetextureui>
                     <usetexturealphaui>false</usetexturealphaui>
                     <isloglincapable>true</isloglincapable>
                     <uselogscale>false</uselogscale>
                     <modified>true</modified>
                    </parameters>
                    <inputnodepins>
                    </inputnodepins>
                   </Node>
                  </nodes>
                  <nodepinconnections>
                  </nodepinconnections>
                 </NodeGraph>
                </internalnodegraph>
               </NodePin>
               <NodePin>
                <typename>gamma</typename>
                <id>3</id>
                <pintype>20001</pintype>
                <hasinternalnodegraph>true</hasinternalnodegraph>
                <basenodeid>1</basenodeid>
                <basenodepinid>0</basenodepinid>
                <internalnodegraph>
                 <NodeGraph>
                  <name>gamma</name>
                  <currentnewnodeid>2</currentnewnodeid>
                  <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
                  <nodes>
                   <Node>
                    <name>gamma</name>
                    <typename>float</typename>
                    <id>1</id>
                    <position>0 0</position>
                    <parameters>
                     <value>1</value>
                     <minvalue>0.1</minvalue>
                     <maxvalue>32</maxvalue>
                     <usetextureui>false</usetextureui>
                     <usetexturealphaui>false</usetexturealphaui>
                     <isloglincapable>true</isloglincapable>
                     <uselogscale>true</uselogscale>
                     <modified>true</modified>
                    </parameters>
                    <inputnodepins>
                    </inputnodepins>
                   </Node>
                  </nodes>
                  <nodepinconnections>
                  </nodepinconnections>
                 </NodeGraph>
                </internalnodegraph>
               </NodePin>
               <NodePin>
                <typename>response</typename>
                <id>4</id>
                <pintype>21000</pintype>
                <hasinternalnodegraph>true</hasinternalnodegraph>
                <basenodeid>1</basenodeid>
                <basenodepinid>0</basenodepinid>
                <internalnodegraph>
                 <NodeGraph>
                  <name>response</name>
                  <currentnewnodeid>2</currentnewnodeid>
                  <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
                  <nodes>
                   <Node>
                    <name>response</name>
                    <typename>camera response</typename>
                    <id>1</id>
                    <position>0 0</position>
                    <parameters>
                     <currentcurveid>105</currentcurveid>
                     <modified>true</modified>
                    </parameters>
                    <inputnodepins>
                    </inputnodepins>
                   </Node>
                  </nodes>
                  <nodepinconnections>
                  </nodepinconnections>
                 </NodeGraph>
                </internalnodegraph>
               </NodePin>
               <NodePin>
                <typename>vignetting</typename>
                <id>5</id>
                <pintype>20001</pintype>
                <hasinternalnodegraph>true</hasinternalnodegraph>
                <basenodeid>1</basenodeid>
                <basenodepinid>0</basenodepinid>
                <internalnodegraph>
                 <NodeGraph>
                  <name>vignetting</name>
                  <currentnewnodeid>2</currentnewnodeid>
                  <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
                  <nodes>
                   <Node>
                    <name>vignetting</name>
                    <typename>float</typename>
                    <id>1</id>
                    <position>0 0</position>
                    <parameters>
                     <value>0.3</value>
                     <minvalue>0</minvalue>
                     <maxvalue>1</maxvalue>
                     <usetextureui>false</usetextureui>
                     <usetexturealphaui>false</usetexturealphaui>
                     <isloglincapable>false</isloglincapable>
                     <uselogscale>false</uselogscale>
                     <modified>true</modified>
                    </parameters>
                    <inputnodepins>
                    </inputnodepins>
                   </Node>
                  </nodes>
                  <nodepinconnections>
                  </nodepinconnections>
                 </NodeGraph>
                </internalnodegraph>
               </NodePin>
               <NodePin>
                <typename>saturation</typename>
                <id>6</id>
                <pintype>20001</pintype>
                <hasinternalnodegraph>true</hasinternalnodegraph>
                <basenodeid>1</basenodeid>
                <basenodepinid>0</basenodepinid>
                <internalnodegraph>
                 <NodeGraph>
                  <name>saturation</name>
                  <currentnewnodeid>2</currentnewnodeid>
                  <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
                  <nodes>
                   <Node>
                    <name>saturation</name>
                    <typename>float</typename>
                    <id>1</id>
                    <position>0 0</position>
                    <parameters>
                     <value>1</value>
                     <minvalue>0</minvalue>
                     <maxvalue>4</maxvalue>
                     <usetextureui>false</usetextureui>
                     <usetexturealphaui>false</usetexturealphaui>
                     <isloglincapable>false</isloglincapable>
                     <uselogscale>false</uselogscale>
                     <modified>true</modified>
                    </parameters>
                    <inputnodepins>
                    </inputnodepins>
                   </Node>
                  </nodes>
                  <nodepinconnections>
                  </nodepinconnections>
                 </NodeGraph>
                </internalnodegraph>
               </NodePin>
               <NodePin>
                <typename>hotpixel_removal</typename>
                <id>7</id>
                <pintype>20001</pintype>
                <hasinternalnodegraph>true</hasinternalnodegraph>
                <basenodeid>1</basenodeid>
                <basenodepinid>0</basenodepinid>
                <internalnodegraph>
                 <NodeGraph>
                  <name>hotpixel_removal</name>
                  <currentnewnodeid>2</currentnewnodeid>
                  <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
                  <nodes>
                   <Node>
                    <name>hotpixel_removal</name>
                    <typename>float</typename>
                    <id>1</id>
                    <position>0 0</position>
                    <parameters>
                     <value>1</value>
                     <minvalue>0</minvalue>
                     <maxvalue>1</maxvalue>
                     <usetextureui>false</usetextureui>
                     <usetexturealphaui>false</usetexturealphaui>
                     <isloglincapable>false</isloglincapable>
                     <uselogscale>false</uselogscale>
                     <modified>true</modified>
                    </parameters>
                    <inputnodepins>
                    </inputnodepins>
                   </Node>
                  </nodes>
                  <nodepinconnections>
                  </nodepinconnections>
                 </NodeGraph>
                </internalnodegraph>
               </NodePin>
               <NodePin>
                <typename>premultiplied_alpha</typename>
                <id>8</id>
                <pintype>20003</pintype>
                <hasinternalnodegraph>true</hasinternalnodegraph>
                <basenodeid>1</basenodeid>
                <basenodepinid>0</basenodepinid>
                <internalnodegraph>
                 <NodeGraph>
                  <name>premultiplied_alpha</name>
                  <currentnewnodeid>2</currentnewnodeid>
                  <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
                  <nodes>
                   <Node>
                    <name>premultiplied_alpha</name>
                    <typename>bool</typename>
                    <id>1</id>
                    <position>0 0</position>
                    <parameters>
                     <value>false</value>
                     <modified>true</modified>
                    </parameters>
                    <inputnodepins>
                    </inputnodepins>
                   </Node>
                  </nodes>
                  <nodepinconnections>
                  </nodepinconnections>
                 </NodeGraph>
                </internalnodegraph>
               </NodePin>
              </inputnodepins>
             </Node>
             <Node>
              <name>Mesh Preview Kernel</name>
              <typename>directlighting</typename>
              <id>6</id>
              <position>0.461 0.8725</position>
              <inputnodepins>
               <NodePin>
                <typename>speculardepth</typename>
                <id>0</id>
                <pintype>20002</pintype>
                <hasinternalnodegraph>true</hasinternalnodegraph>
                <basenodeid>1</basenodeid>
                <basenodepinid>0</basenodepinid>
                <internalnodegraph>
                 <NodeGraph>
                  <name>speculardepth</name>
                  <currentnewnodeid>2</currentnewnodeid>
                  <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
                  <nodes>
                   <Node>
                    <name>speculardepth</name>
                    <typename>int</typename>
                    <id>1</id>
                    <position>0 0</position>
                    <parameters>
                     <value>5</value>
                     <minvalue>1</minvalue>
                     <maxvalue>1024</maxvalue>
                     <isloglincapable>true</isloglincapable>
                     <uselogscale>true</uselogscale>
                     <modified>true</modified>
                    </parameters>
                    <inputnodepins>
                    </inputnodepins>
                   </Node>
                  </nodes>
                  <nodepinconnections>
                  </nodepinconnections>
                 </NodeGraph>
                </internalnodegraph>
               </NodePin>
               <NodePin>
                <typename>glossydepth</typename>
                <id>1</id>
                <pintype>20002</pintype>
                <hasinternalnodegraph>true</hasinternalnodegraph>
                <basenodeid>1</basenodeid>
                <basenodepinid>0</basenodepinid>
                <internalnodegraph>
                 <NodeGraph>
                  <name>glossydepth</name>
                  <currentnewnodeid>2</currentnewnodeid>
                  <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
                  <nodes>
                   <Node>
                    <name>glossydepth</name>
                    <typename>int</typename>
                    <id>1</id>
                    <position>0 0</position>
                    <parameters>
                     <value>1</value>
                     <minvalue>1</minvalue>
                     <maxvalue>1024</maxvalue>
                     <isloglincapable>true</isloglincapable>
                     <uselogscale>true</uselogscale>
                     <modified>true</modified>
                    </parameters>
                    <inputnodepins>
                    </inputnodepins>
                   </Node>
                  </nodes>
                  <nodepinconnections>
                  </nodepinconnections>
                 </NodeGraph>
                </internalnodegraph>
               </NodePin>
               <NodePin>
                <typename>aodist</typename>
                <id>2</id>
                <pintype>20001</pintype>
                <hasinternalnodegraph>true</hasinternalnodegraph>
                <basenodeid>1</basenodeid>
                <basenodepinid>0</basenodepinid>
                <internalnodegraph>
                 <NodeGraph>
                  <name>aodist</name>
                  <currentnewnodeid>2</currentnewnodeid>
                  <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
                  <nodes>
                   <Node>
                    <name>aodist</name>
                    <typename>float</typename>
                    <id>1</id>
                    <position>0 0</position>
                    <parameters>
                     <value>3</value>
                     <minvalue>0.01</minvalue>
                     <maxvalue>1024</maxvalue>
                     <usetextureui>false</usetextureui>
                     <usetexturealphaui>false</usetexturealphaui>
                     <isloglincapable>true</isloglincapable>
                     <uselogscale>true</uselogscale>
                     <modified>true</modified>
                    </parameters>
                    <inputnodepins>
                    </inputnodepins>
                   </Node>
                  </nodes>
                  <nodepinconnections>
                  </nodepinconnections>
                 </NodeGraph>
                </internalnodegraph>
               </NodePin>
               <NodePin>
                <typename>rayepsilon</typename>
                <id>3</id>
                <pintype>20001</pintype>
                <hasinternalnodegraph>true</hasinternalnodegraph>
                <basenodeid>1</basenodeid>
                <basenodepinid>0</basenodepinid>
                <internalnodegraph>
                 <NodeGraph>
                  <name>rayepsilon</name>
                  <currentnewnodeid>2</currentnewnodeid>
                  <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
                  <nodes>
                   <Node>
                    <name>rayepsilon</name>
                    <typename>float</typename>
                    <id>1</id>
                    <position>0 0</position>
                    <parameters>
                     <value>0.0001</value>
                     <minvalue>1e-06</minvalue>
                     <maxvalue>0.1</maxvalue>
                     <usetextureui>false</usetextureui>
                     <usetexturealphaui>false</usetexturealphaui>
                     <isloglincapable>true</isloglincapable>
                     <uselogscale>true</uselogscale>
                     <modified>true</modified>
                    </parameters>
                    <inputnodepins>
                    </inputnodepins>
                   </Node>
                  </nodes>
                  <nodepinconnections>
                  </nodepinconnections>
                 </NodeGraph>
                </internalnodegraph>
               </NodePin>
               <NodePin>
                <typename>maxsamples</typename>
                <id>4</id>
                <pintype>20002</pintype>
                <hasinternalnodegraph>true</hasinternalnodegraph>
                <basenodeid>1</basenodeid>
                <basenodepinid>0</basenodepinid>
                <internalnodegraph>
                 <NodeGraph>
                  <name>maxsamples</name>
                  <currentnewnodeid>2</currentnewnodeid>
                  <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
                  <nodes>
                   <Node>
                    <name>maxsamples</name>
                    <typename>int</typename>
                    <id>1</id>
                    <position>0 0</position>
                    <parameters>
                     <value>64000</value>
                     <minvalue>1</minvalue>
                     <maxvalue>64000</maxvalue>
                     <isloglincapable>true</isloglincapable>
                     <uselogscale>false</uselogscale>
                     <modified>true</modified>
                    </parameters>
                    <inputnodepins>
                    </inputnodepins>
                   </Node>
                  </nodes>
                  <nodepinconnections>
                  </nodepinconnections>
                 </NodeGraph>
                </internalnodegraph>
               </NodePin>
               <NodePin>
                <typename>filtersize</typename>
                <id>5</id>
                <pintype>20001</pintype>
                <hasinternalnodegraph>true</hasinternalnodegraph>
                <basenodeid>1</basenodeid>
                <basenodepinid>0</basenodepinid>
                <internalnodegraph>
                 <NodeGraph>
                  <name>filtersize</name>
                  <currentnewnodeid>2</currentnewnodeid>
                  <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
                  <nodes>
                   <Node>
                    <name>filtersize</name>
                    <typename>float</typename>
                    <id>1</id>
                    <position>0 0</position>
                    <parameters>
                     <value>1.5</value>
                     <minvalue>1</minvalue>
                     <maxvalue>8</maxvalue>
                     <usetextureui>false</usetextureui>
                     <usetexturealphaui>false</usetexturealphaui>
                     <isloglincapable>false</isloglincapable>
                     <uselogscale>false</uselogscale>
                     <modified>true</modified>
                    </parameters>
                    <inputnodepins>
                    </inputnodepins>
                   </Node>
                  </nodes>
                  <nodepinconnections>
                  </nodepinconnections>
                 </NodeGraph>
                </internalnodegraph>
               </NodePin>
               <NodePin>
                <typename>alphachannel</typename>
                <id>6</id>
                <pintype>20003</pintype>
                <hasinternalnodegraph>true</hasinternalnodegraph>
                <basenodeid>1</basenodeid>
                <basenodepinid>0</basenodepinid>
                <internalnodegraph>
                 <NodeGraph>
                  <name>alphachannel</name>
                  <currentnewnodeid>2</currentnewnodeid>
                  <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
                  <nodes>
                   <Node>
                    <name>alphachannel</name>
                    <typename>bool</typename>
                    <id>1</id>
                    <position>0 0</position>
                    <parameters>
                     <value>false</value>
                     <modified>true</modified>
                    </parameters>
                    <inputnodepins>
                    </inputnodepins>
                   </Node>
                  </nodes>
                  <nodepinconnections>
                  </nodepinconnections>
                 </NodeGraph>
                </internalnodegraph>
               </NodePin>
               <NodePin>
                <typename>keep_environment</typename>
                <id>7</id>
                <pintype>20003</pintype>
                <hasinternalnodegraph>true</hasinternalnodegraph>
                <basenodeid>1</basenodeid>
                <basenodepinid>0</basenodepinid>
                <internalnodegraph>
                 <NodeGraph>
                  <name>keep_environment</name>
                  <currentnewnodeid>2</currentnewnodeid>
                  <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
                  <nodes>
                   <Node>
                    <name>keep_environment</name>
                    <typename>bool</typename>
                    <id>1</id>
                    <position>0 0</position>
                    <parameters>
                     <value>false</value>
                     <modified>true</modified>
                    </parameters>
                    <inputnodepins>
                    </inputnodepins>
                   </Node>
                  </nodes>
                  <nodepinconnections>
                  </nodepinconnections>
                 </NodeGraph>
                </internalnodegraph>
               </NodePin>
               <NodePin>
                <typename>alphashadows</typename>
                <id>8</id>
                <pintype>20003</pintype>
                <hasinternalnodegraph>true</hasinternalnodegraph>
                <basenodeid>1</basenodeid>
                <basenodepinid>0</basenodepinid>
                <internalnodegraph>
                 <NodeGraph>
                  <name>alphashadows</name>
                  <currentnewnodeid>2</currentnewnodeid>
                  <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
                  <nodes>
                   <Node>
                    <name>alphashadows</name>
                    <typename>bool</typename>
                    <id>1</id>
                    <position>0 0</position>
                    <parameters>
                     <value>true</value>
                     <modified>true</modified>
                    </parameters>
                    <inputnodepins>
                    </inputnodepins>
                   </Node>
                  </nodes>
                  <nodepinconnections>
                  </nodepinconnections>
                 </NodeGraph>
                </internalnodegraph>
               </NodePin>
               <NodePin>
                <typename>GI_mode</typename>
                <id>9</id>
                <pintype>20002</pintype>
                <hasinternalnodegraph>true</hasinternalnodegraph>
                <basenodeid>1</basenodeid>
                <basenodepinid>0</basenodepinid>
                <internalnodegraph>
                 <NodeGraph>
                  <name>GI_mode</name>
                  <currentnewnodeid>2</currentnewnodeid>
                  <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
                  <nodes>
                   <Node>
                    <name>GI_mode</name>
                    <typename>list int</typename>
                    <id>1</id>
                    <position>0 0</position>
                    <parameters>
                     <value>3</value>
                     <selection>3</selection>
                     <minvalue>0</minvalue>
                     <maxvalue>4</maxvalue>
                     <choice>0 1 2 3 4 </choice>
                     <description_0>Tm9uZQ==</description_0>
                     <description_1>QW1iaWVudA==</description_1>
                     <description_2>U2FtcGxlIGVudmlyb25tZW50</description_2>
                     <description_3>QW1iaWVudCBvY2NsdXNpb24=</description_3>
                     <description_4>RGlmZnVzZQ==</description_4>
                     <modified>true</modified>
                    </parameters>
                    <inputnodepins>
                    </inputnodepins>
                   </Node>
                  </nodes>
                  <nodepinconnections>
                  </nodepinconnections>
                 </NodeGraph>
                </internalnodegraph>
               </NodePin>
               <NodePin>
                <typename>diffusedepth</typename>
                <id>10</id>
                <pintype>20002</pintype>
                <hasinternalnodegraph>true</hasinternalnodegraph>
                <basenodeid>1</basenodeid>
                <basenodepinid>0</basenodepinid>
                <internalnodegraph>
                 <NodeGraph>
                  <name>diffusedepth</name>
                  <currentnewnodeid>2</currentnewnodeid>
                  <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
                  <nodes>
                   <Node>
                    <name>diffusedepth</name>
                    <typename>int</typename>
                    <id>1</id>
                    <position>0 0</position>
                    <parameters>
                     <value>3</value>
                     <minvalue>1</minvalue>
                     <maxvalue>8</maxvalue>
                     <isloglincapable>true</isloglincapable>
                     <uselogscale>false</uselogscale>
                     <modified>true</modified>
                    </parameters>
                    <inputnodepins>
                    </inputnodepins>
                   </Node>
                  </nodes>
                  <nodepinconnections>
                  </nodepinconnections>
                 </NodeGraph>
                </internalnodegraph>
               </NodePin>
               <NodePin>
                <typename>rrprob</typename>
                <id>11</id>
                <pintype>20001</pintype>
                <hasinternalnodegraph>true</hasinternalnodegraph>
                <basenodeid>1</basenodeid>
                <basenodepinid>0</basenodepinid>
                <internalnodegraph>
                 <NodeGraph>
                  <name>rrprob</name>
                  <currentnewnodeid>2</currentnewnodeid>
                  <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
                  <nodes>
                   <Node>
                    <name>rrprob</name>
                    <typename>float</typename>
                    <id>1</id>
                    <position>0 0</position>
                    <parameters>
                     <value>0</value>
                     <minvalue>0</minvalue>
                     <maxvalue>1</maxvalue>
                     <usetextureui>false</usetextureui>
                     <usetexturealphaui>false</usetexturealphaui>
                     <isloglincapable>false</isloglincapable>
                     <uselogscale>false</uselogscale>
                     <modified>true</modified>
                    </parameters>
                    <inputnodepins>
                    </inputnodepins>
                   </Node>
                  </nodes>
                  <nodepinconnections>
                  </nodepinconnections>
                 </NodeGraph>
                </internalnodegraph>
               </NodePin>
              </inputnodepins>
             </Node>
            </nodes>
            <nodepinconnections>
             <nodepinconnection>
              <sourceid>2</sourceid>
              <sourcepinid>0</sourcepinid>
              <destid>1</destid>
              <destpinid>0</destpinid>
             </nodepinconnection>
             <nodepinconnection>
              <sourceid>3</sourceid>
              <sourcepinid>0</sourcepinid>
              <destid>1</destid>
              <destpinid>2</destpinid>
             </nodepinconnection>
             <nodepinconnection>
              <sourceid>4</sourceid>
              <sourcepinid>0</sourcepinid>
              <destid>1</destid>
              <destpinid>1</destpinid>
             </nodepinconnection>
             <nodepinconnection>
              <sourceid>5</sourceid>
              <sourcepinid>0</sourcepinid>
              <destid>1</destid>
              <destpinid>3</destpinid>
             </nodepinconnection>
             <nodepinconnection>
              <sourceid>6</sourceid>
              <sourcepinid>0</sourcepinid>
              <destid>1</destid>
              <destpinid>4</destpinid>
             </nodepinconnection>
            </nodepinconnections>
           </NodeGraph>
          </childgraph>
         </Node>
         <Node>
          <name>template_ocs.obj</name>
          <typename>mesh</typename>
          <id>3</id>
          <position>0.5 0.5</position>
          <objmeshimportparams>
           <overrideDuringMeshImport>false</overrideDuringMeshImport>
           <importMtlMaterials>true</importMtlMaterials>
           <importSmooth>true</importSmooth>
           <useSuppliedVertexNormals>true</useSuppliedVertexNormals>
           <useSuppliedSmoothGroupsAsBoundaries>false</useSuppliedSmoothGroupsAsBoundaries>
           <importImageTextures>true</importImageTextures>
           <diffuse>true</diffuse>
           <glossy>true</glossy>
           <specular>true</specular>
           <roughness>true</roughness>
           <index>true</index>
           <textureDiffuse>true</textureDiffuse>
           <textureSpecular>true</textureSpecular>
           <textureRoughness>true</textureRoughness>
           <textureBump>true</textureBump>
           <textureOpacity>true</textureOpacity>
           <textureDiffuseAsFloatImage>false</textureDiffuseAsFloatImage>
           <textureSpecularAsFloatImage>true</textureSpecularAsFloatImage>
           <textureRoughnessAsFloatImage>true</textureRoughnessAsFloatImage>
           <textureBumpUseScale>true</textureBumpUseScale>
           <textureBumpAsFloatImage>true</textureBumpAsFloatImage>
           <textureOpacityInvert>false</textureOpacityInvert>
           <textureOpacityAsFloatImage>true</textureOpacityAsFloatImage>
           <textureAutoAlphaImage>true</textureAutoAlphaImage>
           <glossySpecularScale>0.5</glossySpecularScale>
           <useMetaCameraObject>false</useMetaCameraObject>
           <cameraMetaObjectName>CAM_TRANSFORM</cameraMetaObjectName>
           <scaleUnitType>4</scaleUnitType>
          </objmeshimportparams>
          <linkedfilename>/home/lionel/tmp/template_ocs.obj</linkedfilename>
          <parameters>
          </parameters>
          <inputnodepins>
           <NodePin>
            <typename>template_material</typename>
            <id>0</id>
            <pintype>20005</pintype>
            <hasinternalnodegraph>true</hasinternalnodegraph>
            <basenodeid>1</basenodeid>
            <basenodepinid>0</basenodepinid>
            <internalnodegraph>
             <NodeGraph>
              <name>template_material</name>
              <currentnewnodeid>8</currentnewnodeid>
              <currentnewnodepinconnectionid>7</currentnewnodepinconnectionid>
              <nodes>
               <Node>
                <name>template_material</name>
                <typename>glossy</typename>
                <id>1</id>
                <position>0 0</position>
                <inputnodepins>
                 <NodePin>
                  <typename>diffuse</typename>
                  <id>0</id>
                  <pintype>20000</pintype>
                  <hasinternalnodegraph>false</hasinternalnodegraph>
                 </NodePin>
                 <NodePin>
                  <typename>specular</typename>
                  <id>1</id>
                  <pintype>20000</pintype>
                  <hasinternalnodegraph>false</hasinternalnodegraph>
                 </NodePin>
                 <NodePin>
                  <typename>roughness</typename>
                  <id>2</id>
                  <pintype>20000</pintype>
                  <hasinternalnodegraph>false</hasinternalnodegraph>
                 </NodePin>
                 <NodePin>
                  <typename>filmwidth</typename>
                  <id>3</id>
                  <pintype>20000</pintype>
                  <hasinternalnodegraph>true</hasinternalnodegraph>
                  <basenodeid>1</basenodeid>
                  <basenodepinid>0</basenodepinid>
                  <internalnodegraph>
                   <NodeGraph>
                    <name>filmwidth</name>
                    <currentnewnodeid>2</currentnewnodeid>
                    <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
                    <nodes>
                     <Node>
                      <name>filmwidth</name>
                      <typename>floattexture</typename>
                      <id>1</id>
                      <position>0 0</position>
                      <parameters>
                       <value>0</value>
                       <minvalue>0</minvalue>
                       <maxvalue>1</maxvalue>
                       <usetexturealphaui>false</usetexturealphaui>
                       <isloglincapable>false</isloglincapable>
                       <uselogscale>false</uselogscale>
                       <resolution>0.001</resolution>
                       <modified>true</modified>
                      </parameters>
                      <inputnodepins>
                      </inputnodepins>
                     </Node>
                    </nodes>
                    <nodepinconnections>
                    </nodepinconnections>
                   </NodeGraph>
                  </internalnodegraph>
                 </NodePin>
                 <NodePin>
                  <typename>filmindex</typename>
                  <id>4</id>
                  <pintype>20001</pintype>
                  <hasinternalnodegraph>true</hasinternalnodegraph>
                  <basenodeid>1</basenodeid>
                  <basenodepinid>0</basenodepinid>
                  <internalnodegraph>
                   <NodeGraph>
                    <name>filmindex</name>
                    <currentnewnodeid>2</currentnewnodeid>
                    <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
                    <nodes>
                     <Node>
                      <name>filmindex</name>
                      <typename>float</typename>
                      <id>1</id>
                      <position>0 0</position>
                      <parameters>
                       <value>1.45</value>
                       <minvalue>1</minvalue>
                       <maxvalue>8</maxvalue>
                       <usetextureui>false</usetextureui>
                       <usetexturealphaui>false</usetexturealphaui>
                       <isloglincapable>true</isloglincapable>
                       <uselogscale>true</uselogscale>
                       <modified>true</modified>
                      </parameters>
                      <inputnodepins>
                      </inputnodepins>
                     </Node>
                    </nodes>
                    <nodepinconnections>
                    </nodepinconnections>
                   </NodeGraph>
                  </internalnodegraph>
                 </NodePin>
                 <NodePin>
                  <typename>bump</typename>
                  <id>5</id>
                  <pintype>20000</pintype>
                  <hasinternalnodegraph>false</hasinternalnodegraph>
                 </NodePin>
                 <NodePin>
                  <typename>normal</typename>
                  <id>6</id>
                  <pintype>20000</pintype>
                  <hasinternalnodegraph>true</hasinternalnodegraph>
                  <basenodeid>1</basenodeid>
                  <basenodepinid>0</basenodepinid>
                  <internalnodegraph>
                   <NodeGraph>
                    <name>normal</name>
                    <currentnewnodeid>2</currentnewnodeid>
                    <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
                    <nodes>
                     <Node>
                      <name>normal</name>
                      <typename>floattexture</typename>
                      <id>1</id>
                      <position>0 0</position>
                      <parameters>
                       <value>0</value>
                       <minvalue>0</minvalue>
                       <maxvalue>1</maxvalue>
                       <usetexturealphaui>false</usetexturealphaui>
                       <isloglincapable>false</isloglincapable>
                       <uselogscale>false</uselogscale>
                       <resolution>0.001</resolution>
                       <modified>true</modified>
                      </parameters>
                      <inputnodepins>
                      </inputnodepins>
                     </Node>
                    </nodes>
                    <nodepinconnections>
                    </nodepinconnections>
                   </NodeGraph>
                  </internalnodegraph>
                 </NodePin>
                 <NodePin>
                  <typename>opacity</typename>
                  <id>7</id>
                  <pintype>20000</pintype>
                  <hasinternalnodegraph>false</hasinternalnodegraph>
                 </NodePin>
                 <NodePin>
                  <typename>smooth</typename>
                  <id>8</id>
                  <pintype>20003</pintype>
                  <hasinternalnodegraph>false</hasinternalnodegraph>
                 </NodePin>
                </inputnodepins>
               </Node>
               <Node>
                <name>diffuse</name>
                <typename>RGBspectrum</typename>
                <id>2</id>
                <position>0 0</position>
                <parameters>
                 <rgbvalue>0.64 0.64 0.64</rgbvalue>
                </parameters>
                <inputnodepins>
                </inputnodepins>
               </Node>
               <Node>
                <name>specular</name>
                <typename>floattexture</typename>
                <id>3</id>
                <position>0 0</position>
                <parameters>
                 <value>0.25</value>
                 <minvalue>0</minvalue>
                 <maxvalue>1</maxvalue>
                 <usetexturealphaui>false</usetexturealphaui>
                 <isloglincapable>false</isloglincapable>
                 <uselogscale>false</uselogscale>
                 <resolution>0.001</resolution>
                 <modified>true</modified>
                </parameters>
                <inputnodepins>
                </inputnodepins>
               </Node>
               <Node>
                <name>roughness</name>
                <typename>floattexture</typename>
                <id>4</id>
                <position>0 0</position>
                <parameters>
                 <value>0.0103093</value>
                 <minvalue>1e-07</minvalue>
                 <maxvalue>1</maxvalue>
                 <usetexturealphaui>false</usetexturealphaui>
                 <isloglincapable>true</isloglincapable>
                 <uselogscale>true</uselogscale>
                 <resolution>1e-07</resolution>
                 <modified>true</modified>
                </parameters>
                <inputnodepins>
                </inputnodepins>
               </Node>
               <Node>
                <name>smooth</name>
                <typename>bool</typename>
                <id>5</id>
                <position>0 0</position>
                <parameters>
                 <value>false</value>
                 <modified>true</modified>
                </parameters>
                <inputnodepins>
                </inputnodepins>
               </Node>
               <Node>
                <name>bump</name>
                <typename>floattexture</typename>
                <id>6</id>
                <position>0 0</position>
                <parameters>
                 <value>0</value>
                 <minvalue>0</minvalue>
                 <maxvalue>1</maxvalue>
                 <usetexturealphaui>false</usetexturealphaui>
                 <isloglincapable>false</isloglincapable>
                 <uselogscale>false</uselogscale>
                 <resolution>0.001</resolution>
                 <modified>true</modified>
                </parameters>
                <inputnodepins>
                </inputnodepins>
               </Node>
               <Node>
                <name>opacity</name>
                <typename>floattexture</typename>
                <id>7</id>
                <position>0 0</position>
                <parameters>
                 <value>1</value>
                 <minvalue>0</minvalue>
                 <maxvalue>1</maxvalue>
                 <usetexturealphaui>true</usetexturealphaui>
                 <isloglincapable>false</isloglincapable>
                 <uselogscale>false</uselogscale>
                 <resolution>0.001</resolution>
                 <modified>true</modified>
                </parameters>
                <inputnodepins>
                </inputnodepins>
               </Node>
              </nodes>
              <nodepinconnections>
               <nodepinconnection>
                <sourceid>2</sourceid>
                <sourcepinid>0</sourcepinid>
                <destid>1</destid>
                <destpinid>0</destpinid>
               </nodepinconnection>
               <nodepinconnection>
                <sourceid>3</sourceid>
                <sourcepinid>0</sourcepinid>
                <destid>1</destid>
                <destpinid>1</destpinid>
               </nodepinconnection>
               <nodepinconnection>
                <sourceid>4</sourceid>
                <sourcepinid>0</sourcepinid>
                <destid>1</destid>
                <destpinid>2</destpinid>
               </nodepinconnection>
               <nodepinconnection>
                <sourceid>5</sourceid>
                <sourcepinid>0</sourcepinid>
                <destid>1</destid>
                <destpinid>8</destpinid>
               </nodepinconnection>
               <nodepinconnection>
                <sourceid>6</sourceid>
                <sourcepinid>0</sourcepinid>
                <destid>1</destid>
                <destpinid>5</destpinid>
               </nodepinconnection>
               <nodepinconnection>
                <sourceid>7</sourceid>
                <sourcepinid>0</sourcepinid>
                <destid>1</destid>
                <destpinid>7</destpinid>
               </nodepinconnection>
              </nodepinconnections>
             </NodeGraph>
            </internalnodegraph>
           </NodePin>
          </inputnodepins>
         </Node>
        </nodes>
        <nodepinconnections>
        </nodepinconnections>
       </NodeGraph>
      </childgraph>
     </Node>
    </OCS_1_0_23_Scene>
    """

template_dl = """
    <Node>
     <name>Mesh Preview Kernel</name>
     <typename>directlighting</typename>
     <id>6</id>
     <position>0.461 0.8725</position>
     <inputnodepins>
      <NodePin>
       <typename>speculardepth</typename>
       <id>0</id>
       <pintype>20002</pintype>
       <hasinternalnodegraph>true</hasinternalnodegraph>
       <basenodeid>1</basenodeid>
       <basenodepinid>0</basenodepinid>
       <internalnodegraph>
        <NodeGraph>
         <name>speculardepth</name>
         <currentnewnodeid>2</currentnewnodeid>
         <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
         <nodes>
          <Node>
           <name>speculardepth</name>
           <typename>int</typename>
           <id>1</id>
           <position>0 0</position>
           <parameters>
            <value>5</value>
            <minvalue>1</minvalue>
            <maxvalue>1024</maxvalue>
            <isloglincapable>true</isloglincapable>
            <uselogscale>true</uselogscale>
            <modified>true</modified>
           </parameters>
           <inputnodepins>
           </inputnodepins>
          </Node>
         </nodes>
         <nodepinconnections>
         </nodepinconnections>
        </NodeGraph>
       </internalnodegraph>
      </NodePin>
      <NodePin>
       <typename>glossydepth</typename>
       <id>1</id>
       <pintype>20002</pintype>
       <hasinternalnodegraph>true</hasinternalnodegraph>
       <basenodeid>1</basenodeid>
       <basenodepinid>0</basenodepinid>
       <internalnodegraph>
        <NodeGraph>
         <name>glossydepth</name>
         <currentnewnodeid>2</currentnewnodeid>
         <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
         <nodes>
          <Node>
           <name>glossydepth</name>
           <typename>int</typename>
           <id>1</id>
           <position>0 0</position>
           <parameters>
            <value>1</value>
            <minvalue>1</minvalue>
            <maxvalue>1024</maxvalue>
            <isloglincapable>true</isloglincapable>
            <uselogscale>true</uselogscale>
            <modified>true</modified>
           </parameters>
           <inputnodepins>
           </inputnodepins>
          </Node>
         </nodes>
         <nodepinconnections>
         </nodepinconnections>
        </NodeGraph>
       </internalnodegraph>
      </NodePin>
      <NodePin>
       <typename>aodist</typename>
       <id>2</id>
       <pintype>20001</pintype>
       <hasinternalnodegraph>true</hasinternalnodegraph>
       <basenodeid>1</basenodeid>
       <basenodepinid>0</basenodepinid>
       <internalnodegraph>
        <NodeGraph>
         <name>aodist</name>
         <currentnewnodeid>2</currentnewnodeid>
         <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
         <nodes>
          <Node>
           <name>aodist</name>
           <typename>float</typename>
           <id>1</id>
           <position>0 0</position>
           <parameters>
            <value>3</value>
            <minvalue>0.01</minvalue>
            <maxvalue>1024</maxvalue>
            <usetextureui>false</usetextureui>
            <usetexturealphaui>false</usetexturealphaui>
            <isloglincapable>true</isloglincapable>
            <uselogscale>true</uselogscale>
            <modified>true</modified>
           </parameters>
           <inputnodepins>
           </inputnodepins>
          </Node>
         </nodes>
         <nodepinconnections>
         </nodepinconnections>
        </NodeGraph>
       </internalnodegraph>
      </NodePin>
      <NodePin>
       <typename>rayepsilon</typename>
       <id>3</id>
       <pintype>20001</pintype>
       <hasinternalnodegraph>true</hasinternalnodegraph>
       <basenodeid>1</basenodeid>
       <basenodepinid>0</basenodepinid>
       <internalnodegraph>
        <NodeGraph>
         <name>rayepsilon</name>
         <currentnewnodeid>2</currentnewnodeid>
         <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
         <nodes>
          <Node>
           <name>rayepsilon</name>
           <typename>float</typename>
           <id>1</id>
           <position>0 0</position>
           <parameters>
            <value>0.0001</value>
            <minvalue>1e-06</minvalue>
            <maxvalue>0.1</maxvalue>
            <usetextureui>false</usetextureui>
            <usetexturealphaui>false</usetexturealphaui>
            <isloglincapable>true</isloglincapable>
            <uselogscale>true</uselogscale>
            <modified>true</modified>
           </parameters>
           <inputnodepins>
           </inputnodepins>
          </Node>
         </nodes>
         <nodepinconnections>
         </nodepinconnections>
        </NodeGraph>
       </internalnodegraph>
      </NodePin>
      <NodePin>
       <typename>maxsamples</typename>
       <id>4</id>
       <pintype>20002</pintype>
       <hasinternalnodegraph>true</hasinternalnodegraph>
       <basenodeid>1</basenodeid>
       <basenodepinid>0</basenodepinid>
       <internalnodegraph>
        <NodeGraph>
         <name>maxsamples</name>
         <currentnewnodeid>2</currentnewnodeid>
         <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
         <nodes>
          <Node>
           <name>maxsamples</name>
           <typename>int</typename>
           <id>1</id>
           <position>0 0</position>
           <parameters>
            <value>64000</value>
            <minvalue>1</minvalue>
            <maxvalue>64000</maxvalue>
            <isloglincapable>true</isloglincapable>
            <uselogscale>false</uselogscale>
            <modified>true</modified>
           </parameters>
           <inputnodepins>
           </inputnodepins>
          </Node>
         </nodes>
         <nodepinconnections>
         </nodepinconnections>
        </NodeGraph>
       </internalnodegraph>
      </NodePin>
      <NodePin>
       <typename>filtersize</typename>
       <id>5</id>
       <pintype>20001</pintype>
       <hasinternalnodegraph>true</hasinternalnodegraph>
       <basenodeid>1</basenodeid>
       <basenodepinid>0</basenodepinid>
       <internalnodegraph>
        <NodeGraph>
         <name>filtersize</name>
         <currentnewnodeid>2</currentnewnodeid>
         <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
         <nodes>
          <Node>
           <name>filtersize</name>
           <typename>float</typename>
           <id>1</id>
           <position>0 0</position>
           <parameters>
            <value>1.5</value>
            <minvalue>1</minvalue>
            <maxvalue>8</maxvalue>
            <usetextureui>false</usetextureui>
            <usetexturealphaui>false</usetexturealphaui>
            <isloglincapable>false</isloglincapable>
            <uselogscale>false</uselogscale>
            <modified>true</modified>
           </parameters>
           <inputnodepins>
           </inputnodepins>
          </Node>
         </nodes>
         <nodepinconnections>
         </nodepinconnections>
        </NodeGraph>
       </internalnodegraph>
      </NodePin>
      <NodePin>
       <typename>alphachannel</typename>
       <id>6</id>
       <pintype>20003</pintype>
       <hasinternalnodegraph>true</hasinternalnodegraph>
       <basenodeid>1</basenodeid>
       <basenodepinid>0</basenodepinid>
       <internalnodegraph>
        <NodeGraph>
         <name>alphachannel</name>
         <currentnewnodeid>2</currentnewnodeid>
         <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
         <nodes>
          <Node>
           <name>alphachannel</name>
           <typename>bool</typename>
           <id>1</id>
           <position>0 0</position>
           <parameters>
            <value>false</value>
            <modified>true</modified>
           </parameters>
           <inputnodepins>
           </inputnodepins>
          </Node>
         </nodes>
         <nodepinconnections>
         </nodepinconnections>
        </NodeGraph>
       </internalnodegraph>
      </NodePin>
      <NodePin>
       <typename>keep_environment</typename>
       <id>7</id>
       <pintype>20003</pintype>
       <hasinternalnodegraph>true</hasinternalnodegraph>
       <basenodeid>1</basenodeid>
       <basenodepinid>0</basenodepinid>
       <internalnodegraph>
        <NodeGraph>
         <name>keep_environment</name>
         <currentnewnodeid>2</currentnewnodeid>
         <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
         <nodes>
          <Node>
           <name>keep_environment</name>
           <typename>bool</typename>
           <id>1</id>
           <position>0 0</position>
           <parameters>
            <value>false</value>
            <modified>true</modified>
           </parameters>
           <inputnodepins>
           </inputnodepins>
          </Node>
         </nodes>
         <nodepinconnections>
         </nodepinconnections>
        </NodeGraph>
       </internalnodegraph>
      </NodePin>
     </inputnodepins>
    </Node>
    <NodePin>
     <typename>alphashadows</typename>
     <id>8</id>
     <pintype>20003</pintype>
     <hasinternalnodegraph>true</hasinternalnodegraph>
     <basenodeid>1</basenodeid>
     <basenodepinid>0</basenodepinid>
     <internalnodegraph>
      <NodeGraph>
       <name>alphashadows</name>
       <currentnewnodeid>2</currentnewnodeid>
       <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
       <nodes>
        <Node>
         <name>alphashadows</name>
         <typename>bool</typename>
         <id>1</id>
         <position>0 0</position>
         <parameters>
          <value>true</value>
          <modified>true</modified>
         </parameters>
         <inputnodepins>
         </inputnodepins>
        </Node>
       </nodes>
       <nodepinconnections>
       </nodepinconnections>
      </NodeGraph>
     </internalnodegraph>
    </NodePin>
    <NodePin>
     <typename>GI_mode</typename>
     <id>9</id>
     <pintype>20002</pintype>
     <hasinternalnodegraph>true</hasinternalnodegraph>
     <basenodeid>1</basenodeid>
     <basenodepinid>0</basenodepinid>
     <internalnodegraph>
      <NodeGraph>
       <name>GI_mode</name>
       <currentnewnodeid>2</currentnewnodeid>
       <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
       <nodes>
        <Node>
         <name>GI_mode</name>
         <typename>list int</typename>
         <id>1</id>
         <position>0 0</position>
         <parameters>
          <value>3</value>
          <selection>3</selection>
          <minvalue>0</minvalue>
          <maxvalue>4</maxvalue>
          <choice>0 1 2 3 4 </choice>
          <description_0>Tm9uZQ==</description_0>
          <description_1>QW1iaWVudA==</description_1>
          <description_2>U2FtcGxlIGVudmlyb25tZW50</description_2>
          <description_3>QW1iaWVudCBvY2NsdXNpb24=</description_3>
          <description_4>RGlmZnVzZQ==</description_4>
          <modified>true</modified>
         </parameters>
         <inputnodepins>
         </inputnodepins>
        </Node>
       </nodes>
       <nodepinconnections>
       </nodepinconnections>
      </NodeGraph>
     </internalnodegraph>
    </NodePin>
    <NodePin>
     <typename>diffusedepth</typename>
     <id>10</id>
     <pintype>20002</pintype>
     <hasinternalnodegraph>true</hasinternalnodegraph>
     <basenodeid>1</basenodeid>
     <basenodepinid>0</basenodepinid>
     <internalnodegraph>
      <NodeGraph>
       <name>diffusedepth</name>
       <currentnewnodeid>2</currentnewnodeid>
       <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
       <nodes>
        <Node>
         <name>diffusedepth</name>
         <typename>int</typename>
         <id>1</id>
         <position>0 0</position>
         <parameters>
          <value>3</value>
          <minvalue>1</minvalue>
          <maxvalue>8</maxvalue>
          <isloglincapable>true</isloglincapable>
          <uselogscale>false</uselogscale>
          <modified>true</modified>
         </parameters>
         <inputnodepins>
         </inputnodepins>
        </Node>
       </nodes>
       <nodepinconnections>
       </nodepinconnections>
      </NodeGraph>
     </internalnodegraph>
    </NodePin>
    <NodePin>
     <typename>rrprob</typename>
     <id>11</id>
     <pintype>20001</pintype>
     <hasinternalnodegraph>true</hasinternalnodegraph>
     <basenodeid>1</basenodeid>
     <basenodepinid>0</basenodepinid>
     <internalnodegraph>
      <NodeGraph>
       <name>rrprob</name>
       <currentnewnodeid>2</currentnewnodeid>
       <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
       <nodes>
        <Node>
         <name>rrprob</name>
         <typename>float</typename>
         <id>1</id>
         <position>0 0</position>
         <parameters>
          <value>0</value>
          <minvalue>0</minvalue>
          <maxvalue>1</maxvalue>
          <usetextureui>false</usetextureui>
          <usetexturealphaui>false</usetexturealphaui>
          <isloglincapable>false</isloglincapable>
          <uselogscale>false</uselogscale>
          <modified>true</modified>
         </parameters>
         <inputnodepins>
         </inputnodepins>
        </Node>
       </nodes>
       <nodepinconnections>
       </nodepinconnections>
      </NodeGraph>
     </internalnodegraph>
    </NodePin>
    """

template_pt = """
    <Node>
     <name>Mesh Preview Kernel</name>
     <typename>pathtracing</typename>
     <id>10</id>
     <position>0.461 0.8725</position>
     <inputnodepins>
      <NodePin>
       <typename>maxdepth</typename>
       <id>0</id>
       <pintype>20002</pintype>
       <hasinternalnodegraph>true</hasinternalnodegraph>
       <basenodeid>1</basenodeid>
       <basenodepinid>0</basenodepinid>
       <internalnodegraph>
        <NodeGraph>
         <name>maxdepth</name>
         <currentnewnodeid>2</currentnewnodeid>
         <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
         <nodes>
          <Node>
           <name>maxdepth</name>
           <typename>int</typename>
           <id>1</id>
           <position>0 0</position>
           <parameters>
            <value>16</value>
            <minvalue>1</minvalue>
            <maxvalue>2048</maxvalue>
            <isloglincapable>true</isloglincapable>
            <uselogscale>true</uselogscale>
            <modified>true</modified>
           </parameters>
           <inputnodepins>
           </inputnodepins>
          </Node>
         </nodes>
         <nodepinconnections>
         </nodepinconnections>
        </NodeGraph>
       </internalnodegraph>
      </NodePin>
      <NodePin>
       <typename>rrprob</typename>
       <id>1</id>
       <pintype>20001</pintype>
       <hasinternalnodegraph>true</hasinternalnodegraph>
       <basenodeid>1</basenodeid>
       <basenodepinid>0</basenodepinid>
       <internalnodegraph>
        <NodeGraph>
         <name>rrprob</name>
         <currentnewnodeid>2</currentnewnodeid>
         <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
         <nodes>
          <Node>
           <name>rrprob</name>
           <typename>float</typename>
           <id>1</id>
           <position>0 0</position>
           <parameters>
            <value>0</value>
            <minvalue>0</minvalue>
            <maxvalue>1</maxvalue>
            <usetextureui>false</usetextureui>
            <usetexturealphaui>false</usetexturealphaui>
            <isloglincapable>false</isloglincapable>
            <uselogscale>false</uselogscale>
            <modified>true</modified>
           </parameters>
           <inputnodepins>
           </inputnodepins>
          </Node>
         </nodes>
         <nodepinconnections>
         </nodepinconnections>
        </NodeGraph>
       </internalnodegraph>
      </NodePin>
      <NodePin>
       <typename>rayepsilon</typename>
       <id>2</id>
       <pintype>20001</pintype>
       <hasinternalnodegraph>true</hasinternalnodegraph>
       <basenodeid>1</basenodeid>
       <basenodepinid>0</basenodepinid>
       <internalnodegraph>
        <NodeGraph>
         <name>rayepsilon</name>
         <currentnewnodeid>2</currentnewnodeid>
         <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
         <nodes>
          <Node>
           <name>rayepsilon</name>
           <typename>float</typename>
           <id>1</id>
           <position>0 0</position>
           <parameters>
            <value>0.0001</value>
            <minvalue>1e-06</minvalue>
            <maxvalue>0.1</maxvalue>
            <usetextureui>false</usetextureui>
            <usetexturealphaui>false</usetexturealphaui>
            <isloglincapable>true</isloglincapable>
            <uselogscale>true</uselogscale>
            <modified>true</modified>
           </parameters>
           <inputnodepins>
           </inputnodepins>
          </Node>
         </nodes>
         <nodepinconnections>
         </nodepinconnections>
        </NodeGraph>
       </internalnodegraph>
      </NodePin>
      <NodePin>
       <typename>maxsamples</typename>
       <id>3</id>
       <pintype>20002</pintype>
       <hasinternalnodegraph>true</hasinternalnodegraph>
       <basenodeid>1</basenodeid>
       <basenodepinid>0</basenodepinid>
       <internalnodegraph>
        <NodeGraph>
         <name>maxsamples</name>
         <currentnewnodeid>2</currentnewnodeid>
         <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
         <nodes>
          <Node>
           <name>maxsamples</name>
           <typename>int</typename>
           <id>1</id>
           <position>0 0</position>
           <parameters>
            <value>64000</value>
            <minvalue>1</minvalue>
            <maxvalue>64000</maxvalue>
            <isloglincapable>true</isloglincapable>
            <uselogscale>false</uselogscale>
            <modified>true</modified>
           </parameters>
           <inputnodepins>
           </inputnodepins>
          </Node>
         </nodes>
         <nodepinconnections>
         </nodepinconnections>
        </NodeGraph>
       </internalnodegraph>
      </NodePin>
      <NodePin>
       <typename>filtersize</typename>
       <id>4</id>
       <pintype>20001</pintype>
       <hasinternalnodegraph>true</hasinternalnodegraph>
       <basenodeid>1</basenodeid>
       <basenodepinid>0</basenodepinid>
       <internalnodegraph>
        <NodeGraph>
         <name>filtersize</name>
         <currentnewnodeid>2</currentnewnodeid>
         <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
         <nodes>
          <Node>
           <name>filtersize</name>
           <typename>float</typename>
           <id>1</id>
           <position>0 0</position>
           <parameters>
            <value>1.5</value>
            <minvalue>1</minvalue>
            <maxvalue>8</maxvalue>
            <usetextureui>false</usetextureui>
            <usetexturealphaui>false</usetexturealphaui>
            <isloglincapable>false</isloglincapable>
            <uselogscale>false</uselogscale>
            <modified>true</modified>
           </parameters>
           <inputnodepins>
           </inputnodepins>
          </Node>
         </nodes>
         <nodepinconnections>
         </nodepinconnections>
        </NodeGraph>
       </internalnodegraph>
      </NodePin>
      <NodePin>
       <typename>alphashadows</typename>
       <id>5</id>
       <pintype>20003</pintype>
       <hasinternalnodegraph>true</hasinternalnodegraph>
       <basenodeid>1</basenodeid>
       <basenodepinid>0</basenodepinid>
       <internalnodegraph>
        <NodeGraph>
         <name>alphashadows</name>
         <currentnewnodeid>2</currentnewnodeid>
         <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
         <nodes>
          <Node>
           <name>alphashadows</name>
           <typename>bool</typename>
           <id>1</id>
           <position>0 0</position>
           <parameters>
            <value>true</value>
            <modified>true</modified>
           </parameters>
           <inputnodepins>
           </inputnodepins>
          </Node>
         </nodes>
         <nodepinconnections>
         </nodepinconnections>
        </NodeGraph>
       </internalnodegraph>
      </NodePin>
      <NodePin>
       <typename>alphachannel</typename>
       <id>6</id>
       <pintype>20003</pintype>
       <hasinternalnodegraph>true</hasinternalnodegraph>
       <basenodeid>1</basenodeid>
       <basenodepinid>0</basenodepinid>
       <internalnodegraph>
        <NodeGraph>
         <name>alphachannel</name>
         <currentnewnodeid>2</currentnewnodeid>
         <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
         <nodes>
          <Node>
           <name>alphachannel</name>
           <typename>bool</typename>
           <id>1</id>
           <position>0 0</position>
           <parameters>
            <value>false</value>
            <modified>true</modified>
           </parameters>
           <inputnodepins>
           </inputnodepins>
          </Node>
         </nodes>
         <nodepinconnections>
         </nodepinconnections>
        </NodeGraph>
       </internalnodegraph>
      </NodePin>
      <NodePin>
       <typename>keep_environment</typename>
       <id>7</id>
       <pintype>20003</pintype>
       <hasinternalnodegraph>true</hasinternalnodegraph>
       <basenodeid>1</basenodeid>
       <basenodepinid>0</basenodepinid>
       <internalnodegraph>
        <NodeGraph>
         <name>keep_environment</name>
         <currentnewnodeid>2</currentnewnodeid>
         <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
         <nodes>
          <Node>
           <name>keep_environment</name>
           <typename>bool</typename>
           <id>1</id>
           <position>0 0</position>
           <parameters>
            <value>false</value>
            <modified>true</modified>
           </parameters>
           <inputnodepins>
           </inputnodepins>
          </Node>
         </nodes>
         <nodepinconnections>
         </nodepinconnections>
        </NodeGraph>
       </internalnodegraph>
      </NodePin>
     </inputnodepins>
    </Node>
    """


template_pmc = """
     <Node>
      <name>Mesh Preview Kernel</name>
      <typename>pmc</typename>
      <id>11</id>
      <position>0.461 0.8725</position>
      <inputnodepins>
       <NodePin>
        <typename>maxdepth</typename>
        <id>0</id>
        <pintype>20002</pintype>
        <hasinternalnodegraph>true</hasinternalnodegraph>
        <basenodeid>1</basenodeid>
        <basenodepinid>0</basenodepinid>
        <internalnodegraph>
         <NodeGraph>
          <name>maxdepth</name>
          <currentnewnodeid>2</currentnewnodeid>
          <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
          <nodes>
           <Node>
            <name>maxdepth</name>
            <typename>int</typename>
            <id>1</id>
            <position>0 0</position>
            <parameters>
             <value>6</value>
             <minvalue>1</minvalue>
             <maxvalue>32</maxvalue>
             <isloglincapable>true</isloglincapable>
             <uselogscale>true</uselogscale>
             <modified>true</modified>
            </parameters>
            <inputnodepins>
            </inputnodepins>
           </Node>
          </nodes>
          <nodepinconnections>
          </nodepinconnections>
         </NodeGraph>
        </internalnodegraph>
       </NodePin>
       <NodePin>
        <typename>rrprob</typename>
        <id>1</id>
        <pintype>20001</pintype>
        <hasinternalnodegraph>true</hasinternalnodegraph>
        <basenodeid>1</basenodeid>
        <basenodepinid>0</basenodepinid>
        <internalnodegraph>
         <NodeGraph>
          <name>rrprob</name>
          <currentnewnodeid>2</currentnewnodeid>
          <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
          <nodes>
           <Node>
            <name>rrprob</name>
            <typename>float</typename>
            <id>1</id>
            <position>0 0</position>
            <parameters>
             <value>0.2</value>
             <minvalue>0</minvalue>
             <maxvalue>1</maxvalue>
             <usetextureui>false</usetextureui>
             <usetexturealphaui>false</usetexturealphaui>
             <isloglincapable>false</isloglincapable>
             <uselogscale>false</uselogscale>
             <modified>true</modified>
            </parameters>
            <inputnodepins>
            </inputnodepins>
           </Node>
          </nodes>
          <nodepinconnections>
          </nodepinconnections>
         </NodeGraph>
        </internalnodegraph>
       </NodePin>
       <NodePin>
        <typename>rayepsilon</typename>
        <id>2</id>
        <pintype>20001</pintype>
        <hasinternalnodegraph>true</hasinternalnodegraph>
        <basenodeid>1</basenodeid>
        <basenodepinid>0</basenodepinid>
        <internalnodegraph>
         <NodeGraph>
          <name>rayepsilon</name>
          <currentnewnodeid>2</currentnewnodeid>
          <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
          <nodes>
           <Node>
            <name>rayepsilon</name>
            <typename>float</typename>
            <id>1</id>
            <position>0 0</position>
            <parameters>
             <value>0.0001</value>
             <minvalue>1e-006</minvalue>
             <maxvalue>0.1</maxvalue>
             <usetextureui>false</usetextureui>
             <usetexturealphaui>false</usetexturealphaui>
             <isloglincapable>true</isloglincapable>
             <uselogscale>true</uselogscale>
             <modified>true</modified>
            </parameters>
            <inputnodepins>
            </inputnodepins>
           </Node>
          </nodes>
          <nodepinconnections>
          </nodepinconnections>
         </NodeGraph>
        </internalnodegraph>
       </NodePin>
       <NodePin>
        <typename>exploration_strength</typename>
        <id>3</id>
        <pintype>20001</pintype>
        <hasinternalnodegraph>true</hasinternalnodegraph>
        <basenodeid>1</basenodeid>
        <basenodepinid>0</basenodepinid>
        <internalnodegraph>
         <NodeGraph>
          <name>exploration_strength</name>
          <currentnewnodeid>2</currentnewnodeid>
          <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
          <nodes>
           <Node>
            <name>exploration_strength</name>
            <typename>float</typename>
            <id>1</id>
            <position>0 0</position>
            <parameters>
             <value>0.7</value>
             <minvalue>0</minvalue>
             <maxvalue>1</maxvalue>
             <usetextureui>false</usetextureui>
             <usetexturealphaui>false</usetexturealphaui>
             <isloglincapable>false</isloglincapable>
             <uselogscale>false</uselogscale>
             <modified>true</modified>
            </parameters>
            <inputnodepins>
            </inputnodepins>
           </Node>
          </nodes>
          <nodepinconnections>
          </nodepinconnections>
         </NodeGraph>
        </internalnodegraph>
       </NodePin>
       <NodePin>
        <typename>direct_light_importance</typename>
        <id>4</id>
        <pintype>20001</pintype>
        <hasinternalnodegraph>true</hasinternalnodegraph>
        <basenodeid>1</basenodeid>
        <basenodepinid>0</basenodepinid>
        <internalnodegraph>
         <NodeGraph>
          <name>direct_light_importance</name>
          <currentnewnodeid>2</currentnewnodeid>
          <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
          <nodes>
           <Node>
            <name>direct_light_importance</name>
            <typename>float</typename>
            <id>1</id>
            <position>0 0</position>
            <parameters>
             <value>0.1</value>
             <minvalue>0.01</minvalue>
             <maxvalue>1</maxvalue>
             <usetextureui>false</usetextureui>
             <usetexturealphaui>false</usetexturealphaui>
             <isloglincapable>true</isloglincapable>
             <uselogscale>true</uselogscale>
             <modified>true</modified>
            </parameters>
            <inputnodepins>
            </inputnodepins>
           </Node>
          </nodes>
          <nodepinconnections>
          </nodepinconnections>
         </NodeGraph>
        </internalnodegraph>
       </NodePin>
       <NodePin>
        <typename>maxrejects</typename>
        <id>5</id>
        <pintype>20002</pintype>
        <hasinternalnodegraph>true</hasinternalnodegraph>
        <basenodeid>1</basenodeid>
        <basenodepinid>0</basenodepinid>
        <internalnodegraph>
         <NodeGraph>
          <name>maxrejects</name>
          <currentnewnodeid>2</currentnewnodeid>
          <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
          <nodes>
           <Node>
            <name>maxrejects</name>
            <typename>int</typename>
            <id>1</id>
            <position>0 0</position>
            <parameters>
             <value>500</value>
             <minvalue>100</minvalue>
             <maxvalue>10000</maxvalue>
             <isloglincapable>true</isloglincapable>
             <uselogscale>true</uselogscale>
             <modified>true</modified>
            </parameters>
            <inputnodepins>
            </inputnodepins>
           </Node>
          </nodes>
          <nodepinconnections>
          </nodepinconnections>
         </NodeGraph>
        </internalnodegraph>
       </NodePin>
       <NodePin>
        <typename>maxsamples</typename>
        <id>6</id>
        <pintype>20002</pintype>
        <hasinternalnodegraph>true</hasinternalnodegraph>
        <basenodeid>1</basenodeid>
        <basenodepinid>0</basenodepinid>
        <internalnodegraph>
         <NodeGraph>
          <name>maxsamples</name>
          <currentnewnodeid>2</currentnewnodeid>
          <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
          <nodes>
           <Node>
            <name>maxsamples</name>
            <typename>int</typename>
            <id>1</id>
            <position>0 0</position>
            <parameters>
             <value>64000</value>
             <minvalue>1</minvalue>
             <maxvalue>64000</maxvalue>
             <isloglincapable>true</isloglincapable>
             <uselogscale>false</uselogscale>
             <modified>true</modified>
            </parameters>
            <inputnodepins>
            </inputnodepins>
           </Node>
          </nodes>
          <nodepinconnections>
          </nodepinconnections>
         </NodeGraph>
        </internalnodegraph>
       </NodePin>
       <NodePin>
        <typename>filtersize</typename>
        <id>7</id>
        <pintype>20001</pintype>
        <hasinternalnodegraph>true</hasinternalnodegraph>
        <basenodeid>1</basenodeid>
        <basenodepinid>0</basenodepinid>
        <internalnodegraph>
         <NodeGraph>
          <name>filtersize</name>
          <currentnewnodeid>2</currentnewnodeid>
          <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
          <nodes>
           <Node>
            <name>filtersize</name>
            <typename>float</typename>
            <id>1</id>
            <position>0 0</position>
            <parameters>
             <value>1.5</value>
             <minvalue>1</minvalue>
             <maxvalue>8</maxvalue>
             <usetextureui>false</usetextureui>
             <usetexturealphaui>false</usetexturealphaui>
             <isloglincapable>false</isloglincapable>
             <uselogscale>false</uselogscale>
             <modified>true</modified>
            </parameters>
            <inputnodepins>
            </inputnodepins>
           </Node>
          </nodes>
          <nodepinconnections>
          </nodepinconnections>
         </NodeGraph>
        </internalnodegraph>
       </NodePin>
       <NodePin>
        <typename>alphashadows</typename>
        <id>8</id>
        <pintype>20003</pintype>
        <hasinternalnodegraph>true</hasinternalnodegraph>
        <basenodeid>1</basenodeid>
        <basenodepinid>0</basenodepinid>
        <internalnodegraph>
         <NodeGraph>
          <name>alphashadows</name>
          <currentnewnodeid>2</currentnewnodeid>
          <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
          <nodes>
           <Node>
            <name>alphashadows</name>
            <typename>bool</typename>
            <id>1</id>
            <position>0 0</position>
            <parameters>
             <value>true</value>
             <modified>true</modified>
            </parameters>
            <inputnodepins>
            </inputnodepins>
           </Node>
          </nodes>
          <nodepinconnections>
          </nodepinconnections>
         </NodeGraph>
        </internalnodegraph>
       </NodePin>
       <NodePin>
        <typename>alphachannel</typename>
        <id>9</id>
        <pintype>20003</pintype>
        <hasinternalnodegraph>true</hasinternalnodegraph>
        <basenodeid>1</basenodeid>
        <basenodepinid>0</basenodepinid>
        <internalnodegraph>
         <NodeGraph>
          <name>alphachannel</name>
          <currentnewnodeid>2</currentnewnodeid>
          <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
          <nodes>
           <Node>
            <name>alphachannel</name>
            <typename>bool</typename>
            <id>1</id>
            <position>0 0</position>
            <parameters>
             <value>false</value>
             <modified>true</modified>
            </parameters>
            <inputnodepins>
            </inputnodepins>
           </Node>
          </nodes>
          <nodepinconnections>
          </nodepinconnections>
         </NodeGraph>
        </internalnodegraph>
       </NodePin>
       <NodePin>
        <typename>keep_environment</typename>
        <id>10</id>
        <pintype>20003</pintype>
        <hasinternalnodegraph>true</hasinternalnodegraph>
        <basenodeid>1</basenodeid>
        <basenodepinid>0</basenodepinid>
        <internalnodegraph>
         <NodeGraph>
          <name>keep_environment</name>
          <currentnewnodeid>2</currentnewnodeid>
          <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
          <nodes>
           <Node>
            <name>keep_environment</name>
            <typename>bool</typename>
            <id>1</id>
            <position>0 0</position>
            <parameters>
             <value>false</value>
             <modified>true</modified>
            </parameters>
            <inputnodepins>
            </inputnodepins>
           </Node>
          </nodes>
          <nodepinconnections>
          </nodepinconnections>
         </NodeGraph>
        </internalnodegraph>
       </NodePin>
      </inputnodepins>
    </Node>
    """

template_sl = """
    <Node>
     <name>Mesh Preview Environment</name>
     <typename>daylight</typename>
     <id>7</id>
     <position>0.403 0.68</position>
     <inputnodepins>
      <NodePin>
       <typename>sundir</typename>
       <id>0</id>
       <pintype>20001</pintype>
       <hasinternalnodegraph>true</hasinternalnodegraph>
       <basenodeid>2</basenodeid>
       <basenodepinid>0</basenodepinid>
       <internalnodegraph>
        <NodeGraph>
         <name>sundir</name>
         <currentnewnodeid>3</currentnewnodeid>
         <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
         <nodes>
          <Node>
           <name>sundir</name>
           <typename>float3</typename>
           <id>2</id>
           <position>0 0</position>
           <parameters>
            <valuexyz>0.566393 0.794672 -0.218391</valuexyz>
            <minvalue>-1</minvalue>
            <maxvalue>1</maxvalue>
            <modified>true</modified>
           </parameters>
           <inputnodepins>
           </inputnodepins>
          </Node>
         </nodes>
         <nodepinconnections>
         </nodepinconnections>
        </NodeGraph>
       </internalnodegraph>
      </NodePin>
      <NodePin>
       <typename>turbidity</typename>
       <id>1</id>
       <pintype>20001</pintype>
       <hasinternalnodegraph>true</hasinternalnodegraph>
       <basenodeid>1</basenodeid>
       <basenodepinid>0</basenodepinid>
       <internalnodegraph>
        <NodeGraph>
         <name>turbidity</name>
         <currentnewnodeid>2</currentnewnodeid>
         <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
         <nodes>
          <Node>
           <name>turbidity</name>
           <typename>float</typename>
           <id>1</id>
           <position>0 0</position>
           <parameters>
            <value>2.2</value>
            <minvalue>0.5</minvalue>
            <maxvalue>16</maxvalue>
            <usetextureui>false</usetextureui>
            <usetexturealphaui>false</usetexturealphaui>
            <isloglincapable>true</isloglincapable>
            <uselogscale>true</uselogscale>
            <modified>true</modified>
           </parameters>
           <inputnodepins>
           </inputnodepins>
          </Node>
         </nodes>
         <nodepinconnections>
         </nodepinconnections>
        </NodeGraph>
       </internalnodegraph>
      </NodePin>
      <NodePin>
       <typename>power</typename>
       <id>2</id>
       <pintype>20001</pintype>
       <hasinternalnodegraph>true</hasinternalnodegraph>
       <basenodeid>1</basenodeid>
       <basenodepinid>0</basenodepinid>
       <internalnodegraph>
        <NodeGraph>
         <name>power</name>
         <currentnewnodeid>2</currentnewnodeid>
         <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
         <nodes>
          <Node>
           <name>power</name>
           <typename>float</typename>
           <id>1</id>
           <position>0 0</position>
           <parameters>
            <value>1</value>
            <minvalue>0.001</minvalue>
            <maxvalue>1000</maxvalue>
            <usetextureui>false</usetextureui>
            <usetexturealphaui>false</usetexturealphaui>
            <isloglincapable>true</isloglincapable>
            <uselogscale>true</uselogscale>
            <modified>true</modified>
           </parameters>
           <inputnodepins>
           </inputnodepins>
          </Node>
         </nodes>
         <nodepinconnections>
         </nodepinconnections>
        </NodeGraph>
       </internalnodegraph>
      </NodePin>
      <NodePin>
       <typename>northoffset</typename>
       <id>3</id>
       <pintype>20001</pintype>
       <hasinternalnodegraph>true</hasinternalnodegraph>
       <basenodeid>1</basenodeid>
       <basenodepinid>0</basenodepinid>
       <internalnodegraph>
        <NodeGraph>
         <name>northoffset</name>
         <currentnewnodeid>2</currentnewnodeid>
         <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
         <nodes>
          <Node>
           <name>northoffset</name>
           <typename>float</typename>
           <id>1</id>
           <position>0 0</position>
           <parameters>
            <value>0</value>
            <minvalue>-1</minvalue>
            <maxvalue>1</maxvalue>
            <usetextureui>false</usetextureui>
            <usetexturealphaui>false</usetexturealphaui>
            <isloglincapable>false</isloglincapable>
            <uselogscale>false</uselogscale>
            <modified>true</modified>
           </parameters>
           <inputnodepins>
           </inputnodepins>
          </Node>
         </nodes>
         <nodepinconnections>
         </nodepinconnections>
        </NodeGraph>
       </internalnodegraph>
      </NodePin>
     </inputnodepins>
    </Node>
    """

template_te = """
    <Node>
     <name>Mesh Preview Environment</name>
     <typename>texture environment</typename>
     <id>7</id>
     <position>0.403 0.68</position>
     <inputnodepins>
      <NodePin>
       <typename>texture</typename>
       <id>0</id>
       <pintype>20000</pintype>
       <hasinternalnodegraph>true</hasinternalnodegraph>
       <basenodeid>1</basenodeid>
       <basenodepinid>0</basenodepinid>
       <internalnodegraph>
        <NodeGraph>
         <name>texture</name>
         <currentnewnodeid>2</currentnewnodeid>
         <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
         <nodes>
          <Node>
           <name>texture</name>
           <typename>floattexture</typename>
           <id>1</id>
           <position>0 0</position>
           <parameters>
            <value>1</value>
            <minvalue>0</minvalue>
            <maxvalue>1</maxvalue>
            <usetexturealphaui>false</usetexturealphaui>
            <isloglincapable>false</isloglincapable>
            <uselogscale>false</uselogscale>
            <resolution>0.001</resolution>
            <modified>true</modified>
           </parameters>
           <inputnodepins>
           </inputnodepins>
          </Node>
         </nodes>
         <nodepinconnections>
         </nodepinconnections>
        </NodeGraph>
       </internalnodegraph>
      </NodePin>
      <NodePin>
       <typename>power</typename>
       <id>1</id>
       <pintype>20001</pintype>
       <hasinternalnodegraph>true</hasinternalnodegraph>
       <basenodeid>1</basenodeid>
       <basenodepinid>0</basenodepinid>
       <internalnodegraph>
        <NodeGraph>
         <name>power</name>
         <currentnewnodeid>2</currentnewnodeid>
         <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
         <nodes>
          <Node>
           <name>power</name>
           <typename>float</typename>
           <id>1</id>
           <position>0 0</position>
           <parameters>
            <value>1</value>
            <minvalue>0.001</minvalue>
            <maxvalue>1000</maxvalue>
            <usetextureui>false</usetextureui>
            <usetexturealphaui>false</usetexturealphaui>
            <isloglincapable>true</isloglincapable>
            <uselogscale>true</uselogscale>
            <modified>true</modified>
           </parameters>
           <inputnodepins>
           </inputnodepins>
          </Node>
         </nodes>
         <nodepinconnections>
         </nodepinconnections>
        </NodeGraph>
       </internalnodegraph>
      </NodePin>
      <NodePin>
       <typename>rotation</typename>
       <id>2</id>
       <pintype>20001</pintype>
       <hasinternalnodegraph>true</hasinternalnodegraph>
       <basenodeid>1</basenodeid>
       <basenodepinid>0</basenodepinid>
       <internalnodegraph>
        <NodeGraph>
         <name>rotation</name>
         <currentnewnodeid>2</currentnewnodeid>
         <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
         <nodes>
          <Node>
           <name>rotation</name>
           <typename>float2</typename>
           <id>1</id>
           <position>0 0</position>
           <parameters>
            <valuexy>0 0</valuexy>
            <minvalue>-1</minvalue>
            <maxvalue>1</maxvalue>
            <modified>true</modified>
           </parameters>
           <inputnodepins>
           </inputnodepins>
          </Node>
         </nodes>
         <nodepinconnections>
         </nodepinconnections>
        </NodeGraph>
       </internalnodegraph>
      </NodePin>
     </inputnodepins>
    </Node>
"""

template_floattexture = """
    <Node>
     <name>texture</name>
     <typename>floattexture</typename>
     <id>1</id>
     <position>0 0</position>
     <parameters>
      <value>1</value>
      <minvalue>0</minvalue>
      <maxvalue>1</maxvalue>
      <usetexturealphaui>false</usetexturealphaui>
      <isloglincapable>false</isloglincapable>
      <uselogscale>false</uselogscale>
      <resolution>0.001</resolution>
      <modified>true</modified>
     </parameters>
     <inputnodepins>
     </inputnodepins>
    </Node>
"""

template_image = """
    <Node>
     <name>texture</name>
     <typename>image</typename>
     <id>2</id>
     <position>0 0</position>
     <linkedfilename>filename.png</linkedfilename>
     <parameters>
     </parameters>
     <inputnodepins>
      <NodePin>
       <typename>power</typename>
       <id>0</id>
       <pintype>20000</pintype>
       <hasinternalnodegraph>true</hasinternalnodegraph>
       <basenodeid>1</basenodeid>
       <basenodepinid>0</basenodepinid>
       <internalnodegraph>
        <NodeGraph>
         <name>power</name>
         <currentnewnodeid>2</currentnewnodeid>
         <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
         <nodes>
          <Node>
           <name>power</name>
           <typename>floattexture</typename>
           <id>1</id>
           <position>0 0</position>
           <parameters>
            <value>1.0</value>
            <minvalue>0</minvalue>
            <maxvalue>1</maxvalue>
            <usetexturealphaui>false</usetexturealphaui>
            <isloglincapable>false</isloglincapable>
            <uselogscale>false</uselogscale>
            <resolution>0.001</resolution>
            <modified>true</modified>
           </parameters>
           <inputnodepins>
           </inputnodepins>
          </Node>
         </nodes>
         <nodepinconnections>
         </nodepinconnections>
        </NodeGraph>
       </internalnodegraph>
      </NodePin>
      <NodePin>
       <typename>gamma</typename>
       <id>1</id>
       <pintype>20001</pintype>
       <hasinternalnodegraph>true</hasinternalnodegraph>
       <basenodeid>1</basenodeid>
       <basenodepinid>0</basenodepinid>
       <internalnodegraph>
        <NodeGraph>
         <name>gamma</name>
         <currentnewnodeid>2</currentnewnodeid>
         <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
         <nodes>
          <Node>
           <name>gamma</name>
           <typename>float</typename>
           <id>1</id>
           <position>0 0</position>
           <parameters>
            <value>2.2</value>
            <minvalue>0.1</minvalue>
            <maxvalue>8</maxvalue>
            <usetextureui>false</usetextureui>
            <usetexturealphaui>false</usetexturealphaui>
            <isloglincapable>true</isloglincapable>
            <uselogscale>true</uselogscale>
            <modified>true</modified>
           </parameters>
           <inputnodepins>
           </inputnodepins>
          </Node>
         </nodes>
         <nodepinconnections>
         </nodepinconnections>
        </NodeGraph>
       </internalnodegraph>
      </NodePin>
      <NodePin>
       <typename>scale</typename>
       <id>2</id>
       <pintype>20001</pintype>
       <hasinternalnodegraph>true</hasinternalnodegraph>
       <basenodeid>1</basenodeid>
       <basenodepinid>0</basenodepinid>
       <internalnodegraph>
        <NodeGraph>
         <name>scale</name>
         <currentnewnodeid>2</currentnewnodeid>
         <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
         <nodes>
          <Node>
           <name>scale</name>
           <typename>float</typename>
           <id>1</id>
           <position>0 0</position>
           <parameters>
            <value>1</value>
            <minvalue>0.001</minvalue>
            <maxvalue>1000</maxvalue>
            <usetextureui>false</usetextureui>
            <usetexturealphaui>false</usetexturealphaui>
            <isloglincapable>true</isloglincapable>
            <uselogscale>true</uselogscale>
            <modified>true</modified>
           </parameters>
           <inputnodepins>
           </inputnodepins>
          </Node>
         </nodes>
         <nodepinconnections>
         </nodepinconnections>
        </NodeGraph>
       </internalnodegraph>
      </NodePin>
      <NodePin>
       <typename>invert</typename>
       <id>3</id>
       <pintype>20003</pintype>
       <hasinternalnodegraph>true</hasinternalnodegraph>
       <basenodeid>1</basenodeid>
       <basenodepinid>0</basenodepinid>
       <internalnodegraph>
        <NodeGraph>
         <name>invert</name>
         <currentnewnodeid>2</currentnewnodeid>
         <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
         <nodes>
          <Node>
           <name>invert</name>
           <typename>bool</typename>
           <id>1</id>
           <position>0 0</position>
           <parameters>
            <value>false</value>
            <modified>true</modified>
           </parameters>
           <inputnodepins>
           </inputnodepins>
          </Node>
         </nodes>
         <nodepinconnections>
         </nodepinconnections>
        </NodeGraph>
       </internalnodegraph>
      </NodePin>
     </inputnodepins>
    </Node>
    """

template_Node_diffuse_RGBspectrum = """
    <Node>
     <name>diffuse</name>
     <typename>RGBspectrum</typename>
     <id>1</id>
     <position>0 0</position>
     <parameters>
      <rgbvalue>0 0 0</value>
     </parameters>
     <inputnodepins>
     </inputnodepins>
    </Node>
    """

template_NodePin_bump_none = """
    <NodePin>
     <typename>bump</typename>
     <id>1</id>
     <pintype>20000</pintype>
     <hasinternalnodegraph>true</hasinternalnodegraph>
     <basenodeid>1</basenodeid>
     <basenodepinid>0</basenodepinid>
     <internalnodegraph>
      <NodeGraph>
       <name>bump</name>
       <currentnewnodeid>2</currentnewnodeid>
       <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
       <nodes>
        <Node>
         <name>bump</name>
         <typename>floattexture</typename>
         <id>1</id>
         <position>0 0</position>
         <parameters>
          <value>0</value>
          <minvalue>0</minvalue>
          <maxvalue>1</maxvalue>
          <usetexturealphaui>false</usetexturealphaui>
          <isloglincapable>false</isloglincapable>
          <uselogscale>false</uselogscale>
          <resolution>0.001</resolution>
          <modified>true</modified>
         </parameters>
         <inputnodepins>
         </inputnodepins>
        </Node>
       </nodes>
       <nodepinconnections>
       </nodepinconnections>
      </NodeGraph>
     </internalnodegraph>
    </NodePin>
    """

template_NodePin_normal_none = """
    <NodePin>
     <typename>normal</typename>
     <id>2</id>
     <pintype>20000</pintype>
     <hasinternalnodegraph>true</hasinternalnodegraph>
     <basenodeid>1</basenodeid>
     <basenodepinid>0</basenodepinid>
     <internalnodegraph>
      <NodeGraph>
       <name>normal</name>
       <currentnewnodeid>2</currentnewnodeid>
       <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
       <nodes>
        <Node>
         <name>normal</name>
         <typename>floattexture</typename>
         <id>1</id>
         <position>0 0</position>
         <parameters>
          <value>0</value>
          <minvalue>0</minvalue>
          <maxvalue>1</maxvalue>
          <usetexturealphaui>false</usetexturealphaui>
          <isloglincapable>false</isloglincapable>
          <uselogscale>false</uselogscale>
          <resolution>0.001</resolution>
          <modified>true</modified>
         </parameters>
         <inputnodepins>
         </inputnodepins>
        </Node>
       </nodes>
       <nodepinconnections>
       </nodepinconnections>
      </NodeGraph>
     </internalnodegraph>
    </NodePin>
    """

template_NodePin_opacity_floattexture = """
    <NodePin>
     <typename>opacity</typename>
     <id>3</id>
     <pintype>20000</pintype>
     <hasinternalnodegraph>true</hasinternalnodegraph>
     <basenodeid>1</basenodeid>
     <basenodepinid>0</basenodepinid>
     <internalnodegraph>
      <NodeGraph>
       <name>opacity</name>
       <currentnewnodeid>2</currentnewnodeid>
       <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
       <nodes>
        <Node>
         <name>opacity</name>
         <typename>floattexture</typename>
         <id>1</id>
         <position>0 0</position>
         <parameters>
          <value>0</value>
          <minvalue>0</minvalue>
          <maxvalue>1</maxvalue>
          <usetexturealphaui>false</usetexturealphaui>
          <isloglincapable>false</isloglincapable>
          <uselogscale>false</uselogscale>
          <resolution>0.001</resolution>
          <modified>true</modified>
         </parameters>
         <inputnodepins>
         </inputnodepins>
        </Node>
       </nodes>
       <nodepinconnections>
       </nodepinconnections>
      </NodeGraph>
     </internalnodegraph>
    </NodePin>
    """

template_NodePin_Emission_null = """
    <NodePin>
     <typename>emission</typename>
     <id>4</id>
     <pintype>20006</pintype>
     <hasinternalnodegraph>true</hasinternalnodegraph>
     <basenodeid>1</basenodeid>
     <basenodepinid>0</basenodepinid>
     <internalnodegraph>
      <NodeGraph>
       <name>emission</name>
       <currentnewnodeid>2</currentnewnodeid>
       <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
       <nodes>
        <Node>
         <name>emission</name>
         <typename>null emission</typename>
         <id>1</id>
         <position>0 0</position>
         <inputnodepins>
         </inputnodepins>
        </Node>
       </nodes>
       <nodepinconnections>
       </nodepinconnections>
      </NodeGraph>
     </internalnodegraph>
    </NodePin>
    """

template_NodePin_smooth = """
    <NodePin>
     <typename>smooth</typename>
     <id>5</id>
     <pintype>20000</pintype>
     <hasinternalnodegraph>true</hasinternalnodegraph>
     <basenodeid>1</basenodeid>
     <basenodepinid>0</basenodepinid>
     <internalnodegraph>
      <NodeGraph>
       <name>smooth</name>
       <currentnewnodeid>2</currentnewnodeid>
       <currentnewnodepinconnectionid>1</currentnewnodepinconnectionid>
       <nodes>
        <Node>
         <name>smooth</name>
         <typename>bool</typename>
         <id>1</id>
         <position>0 0</position>
         <parameters>
          <value>false</value>
          <modified>true</modified>
         </parameters>
         <inputnodepins>
         </inputnodepins>
        </Node>
       </nodes>
       <nodepinconnections>
       </nodepinconnections>
      </NodeGraph>
     </internalnodegraph>
    </NodePin>
    """
